#ifndef __LIBHANDJ__EXTERN_H
#define __LIBHANDJ__EXTERN_H


/* ------------------------------------------------------------------------ */

/* circle.c */

void hgCircle(int px, int py, int radius, byte color);

/* ellipse.c */

void hgEllipse(int px, int py, int a0, int b0, byte color);

/* ------------------------------------------------------------------------ */

/* codeconv.c */

void hgSY2KS(char *str);
void hgKS2SY(char *str);

/* cursor.c */

void hgSetCursorAttr(byte attr);
void hgSetCursorColor(byte color);
void hgSetCursorRate(int rate);

/* extkey.c */

void hgSetExtKey(int *a);
int *hgGetExtKey(void);
void hgFreeExtKey(void);
int  hgGetNumExtKey(void);
void hgSetExtKeyON(void);
void hgSetExtKeyOFF(void);

void hgSetDisableKey(int *a);
int *hgGetDisableKey(void);
void hgFreeDisableKey(void);
int  hgGetNumDisableKey(void);
void hgSetDisableKeyON(void);
void hgSetDisableKeyOFF(void);

/* graphin.c */

void hgInitGraphIn(int keyvalue1, int keyvalue2);

/* hanin.c */

int  hgInText(byte *retn_str, int max);
int  hgInTextXy(int x, int y, byte *retn_str, int max);
int  hgInTextPXy(int px, int py, byte *retn_str, int max);

/* hanjadic.c */

void hgHanjaDicInit(byte *fname, int keyvalue);
void hgHanjaDicEnd(void);

/* hanjain.c */

void hgInitHanjaIn(int keyvalue);

/* inkey.c */

int  hgGetKey(void);
int  hgGetXCh(void);
bool hgKBHit(void);
void hgPause(void);

/* inmode.c */

void hgSetDigitInMode(bool s);
void hgSetEngInMode(bool s);
void hgSetSpcInMode(bool s);

/* insert.c */

void hgSetInsMode(bool s);

/* internal.c */

int  hgGetCh(void);
int  hgGetPos(void);
void hgSetInternal(void (*func)(void));

/* toggle.c */

void hgSetHanMode(bool s);

/* ------------------------------------------------------------------------ */

/* attr.c */

byte hgGetAttr(void);
void hgSetAttr(byte attr);

byte hgGetHanAttr(void);
void hgSetHanAttr(byte attr);

byte hgGetEngAttr(void);
void hgSetEngAttr(byte attr);

byte hgGetExtAttr(void);
void hgSetExtAttr(byte attr);

/* coord.c */

void hgSetRealWindow(int px1, int py1, int px2, int py2);
void hgSetScreenWindow(int px1, int py1, int px2, int py2);

int  hgGetx1r(void);
int  hgGetx2r(void);
int  hgGety1r(void);
int  hgGety2r(void);

int  hgGetx1s(void);
int  hgGetx2s(void);
int  hgGety1s(void);
int  hgGety2s(void);

int  hgGetMaxX(void);
int  hgGetMaxY(void);
int  hgGetMaxPx(void);
int  hgGetMaxPy(void);

/* extern.c */

void hgClrScr(void);
void hgBoxFill(int x1, int y1, int x2, int y2, byte color);
void hgBoxFillPXy(int px1, int py1, int px2, int py2, byte color);

void hgScrUp(int x1, int y1, int x2, int y2, int lines, byte color);
void hgScrUpPXy(int px1, int py1, int px2, int py2, int lines, byte color);
void hgScrDown(int x1, int y1, int x2, int y2, int lines, byte color);
void hgScrDownPXy(int px1, int py1, int px2, int py2, int lines, byte color);

int  hgTextSize(int x1, int y1, int x2, int y2);
void hgGetText(int x1, int y1, int x2, int y2, byte *buff);
void hgPutText(int x1, int y1, int x2, int y2, byte *buff);

int  hgImageSize(int px1, int py1, int px2, int py2);
void hgGetImage(int px1, int py1, int px2, int py2, byte *buff);
void hgPutImage(int px1, int py1, int px2, int py2, byte *buff);

void hgHLine(int px1, int px2, int py, byte color);
void hgVLine(int px, int py1, int py2, byte color);
void hgHLineLen(int px, int py, int length, byte color);
void hgVLineLen(int px, int py, int length, byte color);

void hgDHLine(int px1, int px2, int py);
void hgDVLine(int px, int py1, int py2);
void hgDHLineLen(int px, int py, int length);
void hgDVLineLen(int px, int py, int length);

byte hgGetPlot(int px, int py);
void hgPlot(int px, int py, byte color);

void hgBox(int px1, int py1, int px2, int py2, byte color);
void hgDrawBorder(int px1, int py1, int px2, int py2, int sty[4], int fill);

/* font.c */

int  hgLoadHanFont(byte *hanfile);
int  hgLoadEngFont(byte *engfile);
int  hgLoadSpcFont(byte *spcfile);

void hgSetHanFont(byte *linkedin_hanfont);
void hgSetEngFont(byte *linkedin_engfont);
void hgSetSpcFont(byte *linkedin_spcfont);

/* hanout.c */

int  hgWhereX(void);
int  hgWhereY(void);
void hgGotoXy(int x, int y);

void hgPuts(byte *str);
void hgPutsXy(int x, int y, byte *str);
void hgPutsPXy(int px, int py, byte *str);

void hgPrintf(byte *fmt, ...);
void hgPrintfXy(int x, int y, byte *fmt, ...);
void hgPrintfPXy(int px, int py, byte *fmt, ...);

/* inithan.c */

bool hgIsVGA(void);
bool hgIsVESA(void);

int  hgGetMode(void);
void hgSetTextMode(void);
void hgSetGraphMode(void);

int  hgGetDisplay(void);
int  hgGetMaxColors(void);

byte hgGetBkColor(void);
void hgSetBkColor(byte color);

byte hgGetColor(void);
void hgSetColor(byte color);

/* magnifys.c */

int  hgGetXFactor(void);
void hgSetXFactor(int n);

int  hgGetYFactor(void);
void hgSetYFactor(int n);

/* putback.c */

void hgBackPuts(byte *str, int bkcolor);
void hgBackPutsXy(int x, int y, byte *str, int bkcolor);
void hgBackPutsPXy(int px, int py, byte *str, int bkcolor);

void hgBackPrintf(int bkcolor, byte *fmt, ...);
void hgBackPrintfXy(int x, int y, int bkcolor, byte *fmt, ...);
void hgBackPrintfPXy(int px, int py, int bkcolor, byte *fmt, ...);

/* puteng.c */

void hgEngPuts(byte *str);
void hgEngPutsXy(int x, int y, byte *str);
void hgEngPutsPXy(int px, int py, byte *str);

void hgEngPrintf(byte *fmt, ...);
void hgEngPrintfXy(int x, int y, byte *fmt, ...);
void hgEngPrintfPXy(int px, int py, byte *fmt, ...);

/* putengch.c */

void hgEngPutch(byte num);
void hgEngPutchXy(int x, int y, byte num);
void hgEngPutchPXy(int px, int py, byte num);

/* putfb.c */

void hgFBPuts(byte *str, int color, int bkcolor);
void hgFBPutsXy(int x, int y, byte *str, int color, int bkcolor);
void hgFBPutsPXy(int px, int py, byte *str, int color, int bkcolor);

void hgFBPrintf(int color, int bkcolor, byte *fmt, ...);
void hgFBPrintfXy(int x, int y, int color, int bkcolor, byte *fmt, ...);
void hgFBPrintfPXy(int px, int py, int color, int bkcolor, byte *fmt, ...);

/* putfore.c */

void hgForePuts(byte *str, int color);
void hgForePutsXy(int x, int y, byte *str, int color);
void hgForePutsPXy(int px, int py, byte *str, int color);

void hgForePrintf(int color, byte *fmt, ...);
void hgForePrintfXy(int x, int y, int color, byte *fmt, ...);
void hgForePrintfPXy(int px, int py, int color, byte *fmt, ...);

/* putgraph.c */

void hgLoadGraphFont(byte *fname);
void hgFreeGraphFont(void);
void hgSetGraphFont(byte *linkedin_graphfont);

/* puthanja.c */

void hgLoadHanjaFont(byte *fname);
void hgFreeHanjaFont(void);
void hgSetHanjaFont(byte *linkedin_hanjafont);

/* putover.c */

void hgOverPuts(byte *str);
void hgOverPutsXy(int x, int y, byte *str);
void hgOverPutsPXy(int px, int py, byte *str);

void hgOverPrintf(byte *fmt, ...);
void hgOverPrintfXy(int x, int y, byte *fmt, ...);
void hgOverPrintfPXy(int px, int py, byte *fmt, ...);

/* putspec.c */

void hgSpecPuts(byte *str, int color1, int color2, int deep);
void hgSpecPutsXy(int x, int y, byte *str, int color1, int color2, int deep);
void hgSpecPutsPXy(int px, int py, byte *str, int color1, int color2, int deep);

void hgSpecPrintf(int color1, int color2, int deep, byte *fmt, ...);
void hgSpecPrintfXy(int x, int y, int color1, int color2, int deep, byte *fmt, ...);
void hgSpecPrintfPXy(int px, int py, int color1, int color2, int deep, byte *fmt, ...);

/* set?????.c */

void _VGA640LO(void);
void _VGA320X200HI(void);
void _VGA640X400LO(void);
void _SVGA640HI(void);
void _SVGA640X400HI(void);
void _SVGA800LO(void);
void _SVGA800HI(void);
void _SVGA1024HI(void);

void hgSetDisplay(void (*setdisp)(void), byte *hanfont, byte *engfont);

/* textattr.c */

void hgInitTextAttr(void);
void hgSetTextAttr(bool s);

/* ------------------------------------------------------------------------ */

/* line.c */

void hgLine(int px1, int py1, int px2, int py2, byte color);

/* ------------------------------------------------------------------------ */


#endif
