/* ------------------------------------------------------------------------ */

typedef struct {
    unsigned lasc   : 5;
    unsigned midc   : 5;
    unsigned firc   : 5;
    unsigned dummy  : 1;
} hcode;

typedef struct {
    byte schar;
    byte fchar;
} hchar;

typedef struct {
    int firs, mids, lass;
} HTYPE;

typedef struct {
    int engs;
} ETYPE;

typedef struct {
    FILE *fp;
    int xbyte, ylen;
    int fsize, fnum;
    int is_linkedin;
    byte *buff;
} ExtFont;

/* ------------------------------------------------------------------------ */

extern int hgXbyte;
extern int hgDisplay;
extern int hgColors;
extern byte hgForeColor;
extern byte hgBackColor;

extern byte hgAttr;
extern byte hgHanAttr;
extern byte hgEngAttr;
extern byte hgExtAttr;

extern int hgx1r, hgy1r, hgx2r, hgy2r;
extern int hgXFactor, hgYFactor;

extern byte hgCursorAttr;
extern byte hgCursorColor;
extern int hgCursorRate;

extern int _x_pos, _y_pos;
extern int _px_pos, _py_pos;

extern bool hgDigitInMode;
extern bool hgEngInMode;
extern bool hgSpcInMode;

extern byte *hgKey;
extern byte *hgKeyShifted;
extern byte *hgFirstLast;
extern byte *hgMiddle2;
extern byte *hgLast2;

extern byte *hgInBuff;
extern int hgPos;
extern int hgInMax;
extern int hgSaveCh;
extern int hgXpos, hgYpos;

extern bool hgEngFlag;
extern bool hgGraphOkFlag;
extern bool hgHanjaOkFlag;
extern bool hgSpcEnableFlag;
extern bool hgTextAttrFlag;
extern bool hgInsFlag;
extern bool hgHanMode;

extern byte *fir, *mid, *las, *spc, *eng;
extern byte *Dml, *Dfm, *Dmf;
extern byte *code_table[3];

extern int hgHanjaTable[473][3];


/* ------------------------------------------------------------------------ */

extern void (*hjps)(byte *str, int pos);
extern void (*grps)(byte *str, int pos);
extern void (*atps)(byte *str, int *pos);

extern void (*_clrscr)(void);
extern void (*_boxfill)(int px1, int py1, int px2, int py2, byte color);
extern void (*_scrup)(int px1, int py1, int px2, int py2, int lines, byte color);
extern void (*_scrdn)(int px1, int py1, int px2, int py2, int lines, byte color);
extern int  (*_imgsize)(int px1, int py1, int px2, int py2);
extern void (*_imgget)(int px1, int py1, int px2, int py2, byte *buff);
extern void (*_imgput)(int px1, int py1, int px2, int py2, byte *buff);
extern void (*_lineh)(int px1, int px2, int py, byte color);
extern void (*_linev)(int px, int py1, int py2, byte color);
extern byte (*_plotget)(int px, int py);
extern void (*_plot)(int px, int py, byte color);
extern void (*_puteng)(int px, int py, byte *buff, byte color);
extern void (*_puteng_mag)(int px, int py, byte *buff, byte color);
extern void (*_puthan)(int px, int py, byte *buff, byte color);
extern void (*_puthan_mag)(int px, int py, byte *buff, byte color);
extern void (*_putmag)(int px, int py, byte *buff, int m, int n, byte color);

/* ------------------------------------------------------------------------ */

/* fill13h.c */

void hgBoxFill13h(int px1, int py1, int px2, int py2, byte color);

/* fill16.c */

void hgBoxFill16(int px1, int py1, int px2, int py2, byte color);
void hgBoxFill8x(int px1, int py1, int px2, int py2, byte color);
void fill(int tx1, int py1, int tx2, int py2, byte color);
void sidefill(int tx, int py1, int py2, byte color, byte mask);

/* fill256.c */

void hgBoxFill256(int px1, int py1, int px2, int py2, byte color);

/* ------------------------------------------------------------------------ */

/* circle.c */

void symmetry8(int px, int py, int x, int y, byte color);

/* ellipse.c */

void symmetry4(int px, int py, int x, int y, byte color);

/* ------------------------------------------------------------------------ */

/* clr13h.c */

void hgClrScr13h(void);

/* clr16.c */

void hgClrScr16(void);

/* clr256.c */

void hgClrScr256(void);

/* ------------------------------------------------------------------------ */

/* getmask.c */

byte get_lmask(int px);
byte get_rmask(int px);
byte get_vmask(int px);

/* setpage.c */

void setpage(void);

/* ------------------------------------------------------------------------ */

/* codeconv.c */

word comb2comb(char src, char dest, word code);
int  codecmp(word *p, word *q);
word SY2KS(word code);
word KS2SY(word code);

word hgCodeConv(char src, char dest, word code);
void hgCodeConvStr(char src, char des, char *str);

/* graphin.c */

void proc_graphchoose(void);
void proc_graphin(void);

/* hanin.c */

void hgInitStr(byte *s, int n);
void hgRegisterKeyFunction(int keyvalue, void (*kf)(void));

void proc_english(int ch);                  /* w ɡaa */

void proc_hanin2(int ch);                   /* 2鯢 ɡaa */
void proc_hanin2_ja(void);                  /* aq a */
void proc_hanin2_mo(void);                  /* q a */

byte proc_hanin2_first_by_last(int code);   /*  -> a e */
byte proc_hanin2_last_by_first(int code);   /*  -> a e */
byte proc_hanin2_last2_find(void);          /*  a */
byte proc_hanin2_last2_find_mo(void);       /*  a */

byte proc_hanin_middle2_find(void);         /* q a */
byte proc_hanin_middle2_find_mo(void);      /* qi q    */

int  proc_key(int ch);
void proc_left(void);
void proc_right(void);
void proc_ctrlleft(void);
void proc_ctrlright(void);
void proc_del(void);
void proc_end(void);
void proc_home(void);
void proc_bs(void);
void proc_ins(int n);
void proc_insflag(void);
void proc_return(void);
void proc_space(void);

int  hgBufLen(byte *str);   /* e A bE ia i e */
int  hgIsHangul(void);      /* e  á | ei w ee */
int  hgIsComplete(void);
void hgComplete(void);
void hgComplete2(void);
void hgInitCode(void);

void hgOutputNew(void);           /* ei ša ự w  ai  */
void hgSetCursor(int attribute);  /*  a/ */

/* hanjadic.c */

void proc_hanjadic(void);

/* hanjain.c */

void hgHanjaToHangul(byte *src, byte *dest);
void hgHanjaToHangulSub(byte h1, byte h2, byte *hh1, byte *hh2);

void proc_hanjain(void);

/* inkey.c */

int  inkey(int mode);

/* internal.c */

void in_null(void);
void internal_routine(void);

/* keytable.c */

void hgHanInInit(void);

/* timer.c */

void hgSetTimerZero(void);
int  hgGetTimerTicks(void);

/* ------------------------------------------------------------------------ */

/* attr.c */

void hgDoAttr(byte *dest, int bytes, int n);

void proc_REVERSE(byte *dest, int bytes);
void proc_DIM(byte *dest, int bytes);
void proc_SHADOW(byte *dest, int bytes);
void proc_THREED(byte *dest, int bytes);
void proc_OUTLINE(byte *dest, int bytes);
void proc_BOLD(byte *dest, int bytes);
void proc_UNDER(byte *dest, int bytes);

/* extern.c */

void puteng(int px, int py, byte *buff, byte color);
void puthan(int px, int py, byte *buff, byte color);
void putmag(int px, int py, byte *buff, int m, int n, byte color);

/* extfont.c */

ExtFont *hgOpenExtFont(byte *path, int xbyte, int ylen, byte *linkedin_font);
void     hgCloseExtFont(ExtFont *p);
void     hgPutExtFont(ExtFont *p, int px, int py, int num);

/* hanout.c */

void hanja_null_function(byte *str, int pos);
void pos_null_function(byte *str, int *pos);

void proc_attr(byte *dest, int bytes);
void proc_completehan(int mode, byte *dest, byte *src, int nums);
void proc_engout(byte *str, int pos);
void proc_graphout(byte *str, int pos);
void proc_hanjaout(byte *str, int pos);
void proc_hanout(byte *str, int pos);
void proc_spcout(byte *str, int pos);
void proc_textattr(byte *str, int *pos);

int  isgraphic(byte *str, int pos);
int  ishanja(byte *str, int pos);
int  isspc(byte *str, int pos);

/* putgraph.c */

void graph_real_out(byte *str, int pos);

/* puthanja.c */

void hanja_real_out(byte *str, int pos);

/* putmag.c */

void putch_mn(int px, int py, byte *buff, byte color);

/* putover.c */

void erase_hangul(int px, int py, int color);
void erase_english(int px, int py, int color);

/* textattr.c */

void textattr_real_out(byte *str, int *pos);

/* ------------------------------------------------------------------------ */

/* hvline13h.c */

void hgHLine13h(int px1, int px2, int py, byte color);
void hgVLine13h(int px, int py1, int py2, byte color);

/* hvline16.c */

void hgHLine16(int px1, int px2, int py, byte color);
void hgVLine16(int px, int py1, int py2, byte color);

void byteline(int tx1, int tx2, int py, byte color);
void sideline(int tx, int ty, byte color, byte mask);
void vertline(int tx, int py1, int py2, byte color, byte mask);

/* hvline256.c */

void hgHLine256(int px1, int px2, int py, byte color);
void hgVLine256(int px, int py1, int py2, byte color);

/* ------------------------------------------------------------------------ */

/* image13h.c */

int  hgImageSize13h(int px1, int py1, int px2, int py2);
void hgGetImage13h(int px1, int py1, int px2, int py2, byte *buff);
void hgPutImage13h(int px1, int py1, int px2, int py2, byte *buff);

/* image16.c */

int  hgImageSize16(int px1, int py1, int px2, int py2);
void hgGetImage16(int px1, int py1, int px2, int py2, byte *buff);
void hgPutImage16(int px1, int py1, int px2, int py2, byte *buff);

void getimage16(int tx1, int py1, int tx2, int py2, byte *buff);
void putimage16(int tx1, int py1, int tx2, int py2, byte *buff);

/* image256.c */

int  hgImageSize256(int px1, int py1, int px2, int py2);
void hgGetImage256(int px1, int py1, int px2, int py2, byte *buff);
void hgPutImage256(int px1, int py1, int px2, int py2, byte *buff);

/* ------------------------------------------------------------------------ */

/* plot13h.c */

byte hgGetPlot13h(int px, int py);
void hgPlot13h(int px, int py, byte color);

/* plot16.c */

byte hgGetPlot16(int px, int py);
void hgPlot16(int px, int py, byte color);

/* plot256.c */

byte hgGetPlot256(int px, int py);
void hgPlot256(int px, int py, byte color);

/* ------------------------------------------------------------------------ */

/* magnify.c */

void lengthen(byte *s1, byte *s2, int xbytes, int yscan);
int  pw(int a, int b);
void widen(byte *s1, byte *s2, int bytes);
void widen_sub(byte *s1, byte *s2, int bytes);

/* put13h.c */

void putch_eng13h(int px, int py, byte *buff, byte color);
void putch_han13h(int px, int py, byte *buff, byte color);
void putch_mag13h(int px, int py, byte *buff, int m, int n, byte color);

/* put16.c */

void putch_eng16(int px, int py, byte *buff, byte color);
void putch_eng16_8x(int px, int py, byte *buff, byte color);

void putch_han16(int px, int py, byte *buff, byte color);
void putch_han16_8x(int px, int py, byte *buff, byte color);

void putch_mag16(int px, int py, byte *buff, int m, int n, byte color);
void putch_mag16_8x(int px, int py, byte *buff, int m, int n, byte color);

/* put256.c */

void putch_eng256(int px, int py, byte *buff, byte color);
void putch_han256(int px, int py, byte *buff, byte color);
void putch_mag256(int px, int py, byte *buff, int m, int n, byte color);

/* ------------------------------------------------------------------------ */

/* scr13h.c */

void hgScrUp13h(int px1, int py1, int px2, int py2, int lines, byte bkcolor);
void hgScrDown13h(int px1, int py1, int px2, int py2, int lines, byte bkcolor);

/* scr16.c */

void hgScrUp16(int px1, int py1, int px2, int py2, int lines, byte bkcolor);
void hgScrDown16(int px1, int py1, int px2, int py2, int lines, byte bkcolor);

void hgScrUp8x(int px1, int py1, int px2, int py2, int lines, byte bkcolor);
void hgScrDown8x(int px1, int py1, int px2, int py2, int lines, byte bkcolor);

void scrdn(int px1, int py1, int px2, int py2, int lines);
void scrup(int tx1, int py1, int tx2, int py2, int lines);
void scrsideup(int tx, int py1, int py2, int lines, byte mask);
void scrsidedn(int tx, int py1, int py2, int lines, byte mask);

/* scr256.c */

void hgScrUp256(int px1, int py1, int px2, int py2, int lines, byte bkcolor);
void hgScrDown256(int px1, int py1, int px2, int py2, int lines, byte bkcolor);

/* ------------------------------------------------------------------------ */

