#ifndef __LIBHANDJ__WINDOW_H
#define __LIBHANDJ__WINDOW_H


/* ------------------------------------------------------------------------ */

#include <stdio.h>

#define ERASE           0
#define DRAW            1

#define HORIZ           0
#define VERT            1

#define NOFILL          0
#define FILL            1

#define PUSH            0
#define NOPUSH          1

#define hgDisable       0
#define hgEnable        1

#define wcINSIDE        0
#define wcINSIDE2       1
#define wcBOXNORMAL     2
#define wcBOXREVERSE    3
#define wcBLUEBOX       4
#define wcBARNORMAL     5
#define wcBARREVERSE    6
#define wcERASER        7

#define INSIDE          dft_bstyle[0]
#define INSIDE2         dft_bstyle[1]
#define BOXNORMAL       dft_bstyle[2]
#define BOXREVERSE      dft_bstyle[3]
#define BLUEBOX         dft_bstyle[4]
#define BARNORMAL       dft_bstyle[5]
#define BARREVERSE      dft_bstyle[6]
#define ERASER          dft_bstyle[7]

#define DITHER_GRAY     &dither_gray
#define DITHER_PATTERN  &dither_pattern

#define MAXITEM         15
#define MAXPOPUP        15
#define _MAXDIR         200
#define MAXHELPLINE     100
#define MAXSTYLE        20
#define MAXSTACK        50
#define MAXBUTTON       10


/* ------------------------------------------------------------------------ */

/*  aaw */

typedef struct {
    int xwidth;
    int ywidth;
} hgWIDTH;

typedef struct {
    int border;
    int tfore;
    int tback;
    int back;
} hgWCOLOR;

typedef struct {
    int border;
    int back;
} hgBCOLOR;

typedef struct {
    int back;
    int color1;
    int color2;
    int deep;
} hgBSTYLE;


/* ------------------------------------------------------------------------ */

/*  aaw */

typedef struct {
    byte *titl;
    hgWIDTH size;
    hgWCOLOR color;
} hgHWINDOW;

typedef struct {
    byte *items[MAXITEM];
    hgWCOLOR color;
    hgWIDTH size;
    byte *buff;
} hgHBOX;

typedef struct {
    hgBCOLOR color;
    hgWIDTH size;
    byte *buff;
} hgHBAR;

typedef struct {
    byte *item;
    hgWIDTH size;
    hgWCOLOR color;
} hgHBUTTON;


/* ------------------------------------------------------------------------ */

/* s aaw */

typedef struct {
    byte *items[MAXITEM];
    hgWCOLOR color;
    hgWIDTH size;
    byte *buff;
    int start;
    int code[MAXITEM];
} hgHPOPUP;

typedef struct {
    byte *items[MAXITEM];
    int xpos[MAXITEM];
    hgWIDTH size;
    hgHPOPUP *p[MAXPOPUP];
    int code[MAXITEM];
    int start;
} hgHPULLDOWN;

typedef struct {
    hgWIDTH size;
    int total;
    int screen;
    int pos;
    int direc;
} hgHSCRLBAR;

typedef struct {
    byte *items[MAXHELPLINE];
    int xchars;
    int ylines;
} hgHHELP;

typedef struct {
    byte *items[_MAXDIR];
    hgWIDTH size;
    int xnum;
    int ynum;
} hgHDIRBOX;

typedef struct {
    hgWIDTH size;
    byte *buff;
} hgHICON;


/* ------------------------------------------------------------------------ */

extern int xn, xp, maxlen;
extern int xb[], xw[], xe[];

extern int wintitlefore;
extern int wintitleback;
extern int winback;
extern int winborder;

extern int dspos;
extern int dft_bstyle[MAXSTYLE][4];

extern bool hgSaveFlag;


/* ------------------------------------------------------------------------ */

/* dither.c */

void hgSetDither(void (*p)());
void hgDoDither(hgHICON *p);

void dither_gray(hgHICON *p);
void dither_pattern(hgHICON *p);

/* hbar.c */

hgHBAR      *hgHBAR_Load(hgBCOLOR c, hgWIDTH w);
void         hgHBAR_Free(hgHBAR **p);
void         hgHBAR_Draw(hgHBAR *p, int px, int py, int mode);

/* hbasic.c */

void         hgWIDTH_Load(hgWIDTH *p, int xwidth, int ywidth);
void         hgWCOLOR_Load(hgWCOLOR *p, int border, int tfore, int tback, int back);
void         hgBCOLOR_Load(hgBCOLOR *p, int border, int back);
void         hgBSTYLE_Load(hgBSTYLE *p, int back, int color1, int color2, int deep);

/* hbox.c */

hgHBOX      *hgHBOX_Load(byte *i[], hgWCOLOR c, hgWIDTH w);
void         hgHBOX_Free(hgHBOX **p);
void         hgHBOX_Draw(hgHBOX *p, int px, int py);
void         hgHBOX_Save(hgHBOX *p, int px, int py);
void         hgHBOX_Restore(hgHBOX *p, int px, int py);

/* hbutton.c */

hgHBUTTON   *hgHBUTTON_Load(byte *i, hgWCOLOR c, hgWIDTH w);
void         hgHBUTTON_Free(hgHBUTTON **p);
void         hgHBUTTON_Draw(hgHBUTTON *p, int px, int py, int mode);

/* hdirbox.c */

hgHDIRBOX   *hgHDIRBOX_Load(byte *i[], hgWIDTH w, int xnum, int ynum);
void         hgHDIRBOX_Free(hgHDIRBOX **p);
void         hgHDIRBOX_Choose(hgHDIRBOX *p, int px, int py, byte *title, byte *ret);

void print_oneline(int x, int y, byte *items[], int pos, int num, int xnum, int xincre);
void hgSetRecPos(bool s);
void hgChangeDirBox(int a, int b, int c);
void hgSetDirBox(int a, int b, int c);
void hgGetDirBox(int *a, int *b, int *c);

/* hhelp.c */

hgHHELP     *hgHHELP_Load(byte *i[], int xc, int yl);
void         hgHHELP_Free(hgHHELP **p);
void         hgHHELP_Draw(hgHHELP *p, int px, int py, byte *title);

void print_help_sub(int px, int py, byte *buff[], int max, int sline, int ylines, int xsize);

/* hicon.c */

hgHICON     *hgHICON_Load(byte *fname);
void         hgHICON_Free(hgHICON **p);
void         hgHICON_Draw(hgHICON *p, int px, int py);
hgHICON     *hgHICON_Set(void (*iconset)(hgHICON *p));
int          hgHICON_IsIcon(byte *fname);

int get_pos(hgHICON *p, int px, int py);

/* hpopup.c */

hgHPOPUP    *hgHPOPUP_Load(byte *i[], hgWCOLOR c, hgWIDTH w);
void         hgHPOPUP_Loadcode(hgHPOPUP *p, int c[MAXITEM]);
void         hgHPOPUP_Free(hgHPOPUP **p);
int          hgHPOPUP_Choose(hgHPOPUP *p, int px, int py, int start);

/* hpulldn.c */

hgHPULLDOWN *hgHPULLDOWN_Load(byte *i[], int x[MAXITEM], hgWIDTH w, hgHPOPUP *pop[MAXPOPUP]);
void         hgHPULLDOWN_Loadcode(hgHPULLDOWN *p, int c[MAXITEM]);
void         hgHPULLDOWN_Free(hgHPULLDOWN **p);
void         hgHPULLDOWN_Choose(hgHPULLDOWN *p, int px, int py, int start, int *xx, int *yy);

/* hscrbar.c */

hgHSCRLBAR  *hgHSCRLBAR_Load(int total, int screen, int direc, hgWIDTH w);
void         hgHSCRLBAR_Free(hgHSCRLBAR **p);
void         hgHSCRLBAR_Draw(hgHSCRLBAR *p, int px, int py);
void         hgHSCRLBAR_Update(hgHSCRLBAR *p, int px, int py);
void         hgHSCRLBAR_Choose(hgHSCRLBAR *p, int px, int py);
int          hgHSCRLBAR_Area(hgHSCRLBAR *p, int px, int py);

/* hwindow.c */

hgHWINDOW   *hgHWINDOW_Load(byte *t, hgWCOLOR c, hgWIDTH s);
void         hgHWINDOW_Free(hgHWINDOW **p);
void         hgHWINDOW_Draw(hgHWINDOW *p, int px, int py);
void         hgHWINDOW_Clrscr(hgHWINDOW *p, int px, int py);
void         hgHWINDOW_ScrUp(hgHWINDOW *p, int px, int py, int n);
void         hgHWINDOW_ScrDown(hgHWINDOW *p, int px, int py, int n);

/* qbar.c */

void hgPrtBarPXy(int px1, int px2, int py);
void hgPrtBarSavePXy(int px1, int px2, int py, int mode);

/* qbox.c */

void hgPrtBoxPXy(int px1, int py1, int px2, int py2, byte *items[]);
void hgPrtBoxM(byte *items[]);

/* qbutton.c */

void hgPrtButtonPXy(int px, int py, byte *text, int mode);
void hgPrtButtonM(byte *text, int mode);
int  hgPrtButtonBarPXy(int px1, int py1, int px2, int py2, byte *msg[], byte *items[]);
int  hgPrtButtonBarM(byte *msg[], byte *items[]);
int  hgPrtButtonBarPXyQ(int px, int py, byte *msg[], byte *items[]);

/* qfilebox.c */

int  hgFileDirBoxPXy(int px, int py, byte *fname, byte *ret);
int  hgFileDirBoxM(byte *fname, byte *ret);
void hgSelectDirBoxPXy(int px, int py, byte *items[], byte *title, byte *ret);
void hgSelectDirBoxM(byte *items[], byte *title, byte *ret);

void directory(int px, int py, byte mask[20], byte *rtn);

/* qhelpbox.c */

void hgPrtHelpBoxPXy(int px, int py, byte *items[], int xw, int yw, byte *title);
void hgPrtHelpBoxM(byte *items[], int xw, int yw, byte *title);
int  hgFileHelpBoxPXy(byte *helpfile, byte *indexfile, int px, int py, int xw, int yw, byte *key);
int  hgFileHelpBoxM(byte *helpfile, byte *indexfile, int xw, int yw, byte *title);

int  keysearch(FILE *idx, byte *key);

/* qicon.c */

void hgPrtTextIconPXy(hgHICON *p, int px, int py, byte *str);
void hgPrtIconBarPXy(hgHICON *p, int px, int py);
void hgPrtIconBarSavePXy(hgHICON *p, int px, int py, int mode);

/* qinput.c */

int hgInWTextPXy(int px, int py, byte *title, byte *str, int n);
int hgInWTextM(byte *title, byte *str, int n);

/* qpulldn.c */

void hgPrtPullWindowPXy(hgHPULLDOWN *p, byte *title, int px, int py1, int py2);
void hgPrtPullDownPXy(hgHPULLDOWN *p, int px, int py, int start, int *xx, int *yy);

/* qselbox.c */

int hgSelectPXy(int px1, int py1, int px2, int py2, byte *items[], int start);
int hgSelectM(byte *items[], int start);
int hgSelectPXyQ(int px, int py, byte *items[], int start);

/* qwindow.c */

void hgPrtWindowPXy(int px1, int py1, int px2, int py2, byte *title);
void hgPrtWTextPXy(int px1, int py1, int px2, int py2, byte *title, byte *text[]);
void hgPrtWTextM(byte *title, byte *text[]);
void hgPrtWTextPXyQ(int x, int y, byte *title, byte *text[]);
void hgRetMSizePXy(byte *text[], int *px1, int *py1, int *px2, int *py2);
void hgRestore(void);
void hgDelete(void);

void savearea(int px1, int py1, int px2, int py2);
int  ret_number(byte *text[]);
int  ret_maxlength(byte *text[]);

/* qwinset.c */

void hgClearWindowPXy(int px1, int py1, int px2, int py2);
void hgColorWindowPXy(int px1, int py1, int px2, int py2, int color);
void hgScrUpWindowPXy(int px1, int py1, int px2, int py2, int n);
void hgScrDownWindowPXy(int px1, int py1, int px2, int py2, int n);
void hgSetTitleFore(int color);
void hgSetTitleBack(int color);
int  hgGetTitleFore(void);
int  hgGetTitleBack(void);
void hgSetWinBack(int style);
int  hgGetWinBorder(void);
void hgSetSaveON(void);
void hgSetSaveOFF(void);

/* style.c */

int  hgAddStyle(int back, int color1, int color2, int deep);
void hgAdjustStyle(void);

/* ------------------------------------------------------------------------ */


#endif
