/*
**      a  w : fill16.c
**       I w :  ba a (16 a)
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


void hgBoxFill16(int px1, int py1, int px2, int py2, byte color)
{
    int xs, xe;
    byte rmask, lmask;

    if ((px1 % 8 == 0) && ((px2 + 1) % 8 == 0)) {
        hgBoxFill8x(px1, py1, px2, py2, color);
        return;
    }

    xs = px1 / 8 + 1;
    xe = px2 / 8 - 1;

    rmask = get_rmask(px2);
    lmask = get_lmask(px1);

    fill(xs, py1, xe, py2, color);
    sidefill(xs - 1, py1, py2, color, lmask);
    sidefill(xe + 1, py1, py2, color, rmask);
}

void hgBoxFill8x(int px1, int py1, int px2, int py2, byte color)
{
    fill(px1 / 8, py1, px2 / 8, py2, color);
}

void fill(int tx1, int py1, int tx2, int py2, byte color)
{
    int x_width = tx2 - tx1 + 1;
    int y_width = py2 - py1 + 1;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl $0x03ce, %%edx
        movl $0x0205, %%eax
        outw %%ax, %%dx
        movl $0xff08, %%ax
        outw %%ax, %%dx

        movl %6, %%ecx
        movl %3, %%eax
        movl %1, %%ebx
        mulw %%bx
        addl %2, %%eax
        addl $0xa0000, %%eax
        addl %0, %%eax

        movl %%eax, %%ebx
        movb %4, %%al

fill__boxlp1:

        pushl %%ecx
        movl %5, %%ecx
        movl %%ebx, %%edi

fill__boxlp2:

        REP
        stosb
        addl %1, %%ebx
        popl %%ecx
        loop fill__boxlp1

        movl $0x03ce, %%edx
        movl $5, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx1), "g" (py1), "g" (color), "g" (x_width), "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void sidefill(int tx, int py1, int py2, byte color, byte mask)
{
    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %4, %%ecx
        subl %3, %%ecx
        incl %%ecx

        movl %1, %%ebx
        movl %3, %%eax
        mulw %%bx
        addl %2, %%eax
        addl $0xa0000, %%eax
        addl %0, %%eax
        movl %%eax, %%edi

        movl $0x03ce, %%edx
        movl $0x0205, %%eax
        outw %%ax, %%dx

        movb $8, %%al
        movb %6, %%ah
        outw %%ax, %%dx

        movb %5, %%ah

sidefill__fill:

        movb (%%edi), %%al
        movb %%ah, (%%edi)
        addl %1, %%edi
        loop sidefill__fill

        movl $0x0005, %%eax
        outw %%ax, %%dx
        movl $0xff08, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx), "g" (py1), "g" (py2), "g" (color), "g" (mask)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

