/*
**      a  w : fill256.c
**       I w :  ba a (256 a)
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


void hgBoxFill256(int px1, int py1, int px2, int py2, byte color)
{
    int x_width = px2 - px1 + 1;
    int y_width = py2 - py1 + 1;

    __asm__ __volatile__("
        pushw %%es
        movw %0, %%es

        xorl %%ecx, %%ecx

        movl %3, %%eax
        movl %1, %%ebx
        mulw %%bx
        addw %2, %%ax
        adcl $0, %%edx              /* dl = A ѡ */
        movl %%eax, %%ebx
        addl $0xa0000, %%ebx        /* ebx = aU (0xa????) */

        call _setpage               /* 币 A */

        movb %4, %%al               /* al = t */
        movb %%al, %%ah
        movl %6, %%ecx              /* ecx = y_width (A e U) */

hgBoxFill256__lp_y:

        pushl %%ecx
        movl %%ebx, %%edi           /* edi =  aU w */
        addw %5, %%di               /* di = di + x_width */
        jc hgBoxFill256__paging     /* 0xaffffa ae A */

        /* A ϩae w ----------------------------------------- */

hgBoxFill256__no_paging:            /* A ϩae w */

        movl %5, %%ecx              /* a e  aa  */
        subw %5, %%di               /* di = di - x_width (aU ) */
        cld
        REP
        stosb                       /* a e a */

        jmp hgBoxFill256__next1

        /* A ϩae w ------------------------------------------- */

hgBoxFill256__paging:

        subw %5, %%di               /* di = di - x_width (aU ) */
        movw %%di, %%cx
        negw %%cx                   /* cx = A w E  aa */

        cld
        REP
        stosb                       /* E  a */

        movl %%ebx, %%edi           /*  aU  */
        addw %5, %%di               /* di = di + x_width */

        incl %%edx                  /* A ѡ wa */
        call _setpage               /* A */
        movw %%di, %%cx             /* cx = e  e U */
        xorw %%di, %%di             /* di = 0 (aU ba) */

        REP
        stosb                       /* e  a */

hgBoxFill256__next1:

        addw %1, %%bx               /* e aU  */
        cmpw %%di, %%bx             /*  弁 A a */
        jae hgBoxFill256__next2     /* bx >= die next2 (A ϩa) */

        incl %%edx                  /* bx < di e A ѡ wa */
        call _setpage               /* a A */

hgBoxFill256__next2:

        popl %%ecx
        loop hgBoxFill256__lp_y

        popw %%es
        "
        :
        : "g" (_dos_ds), "g" (hgXbyte),
          "g" (px1), "g" (py1), "g" (color),
          "g" (x_width), "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );
}

