/*
**      a  w : hanin.c
**       I w : ei b ɡaa  b q
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"
#include "_keycode.h"


/* ------------------------------------------------------------------------ */

#define MID_OFF             100
#define LAST_OFF            200

#define NO_CODE             0
#define OFF2                2
#define OFF0                0

#define EMPTY               1
#define EMPTY2              2

#define _SPECIAL_KEYCODE    0
#define _NORMAL_KEYCODE     -1
#define _EXIT_KEYCODE       1
#define _DISABLE_KEYCODE    -2

#define MAXKEYFUNC          20

#define CursREVERSE         0
#define CursNORMAL          1


/* ------------------------------------------------------------------------ */

union {
    hcode c;
    hchar b;
} hanin;

byte *hgKey;
byte *hgKeyShifted;
byte *hgFirstLast;
byte *hgMiddle2;
byte *hgLast2;

bool hgHanMode = hgFALSE;
bool hgInsFlag = hgTRUE;

byte *hgInBuff;

int hgHcode;
int hgPos;
int hgXpos, hgYpos;
int hgInMax;
int hgSaveCh;

int hgKeys[MAXKEYFUNC] = {
    INS, BS, HOME, END, DEL, LEFT, RIGHT, RETURN, ESC, SPACE
};

int hgKeyNum = 10;

void (*hgKeyFunc[MAXKEYFUNC])(void) = {
    proc_insflag,
    proc_bs,
    proc_home,
    proc_end,
    proc_del,
    proc_left,
    proc_right,
    proc_return,
    proc_return,
    proc_space
};


/* ------------------------------------------------------------------------ */

void hgInitStr(byte *s, int n)
{
    memset(s, 0, n - 1);
}

int hgInText(byte *retn_str, int max)
{
    return hgInTextXy(_x_pos, _y_pos, retn_str, max);
}

int hgInTextXy(int x, int y, byte *retn_str, int max)
{
    return hgInTextPXy(8 * (x - 1), 16 * (y - 1), retn_str, max);
}

int hgInTextPXy(int px, int py, byte *retn_str, int max)
{
    int ch, i, i2;
    int *ext, extflag;
    int xfac, yfac, saveticks;
    bool reversemode = hgTRUE;
    bool ishan = hgFALSE;
    int saveeng, savehan, modesave;

    saveeng = hgEngAttr;
    savehan = hgHanAttr;

    xfac = hgXFactor;
    yfac = hgYFactor;

    hgXFactor = 1;
    hgYFactor = 1;

    hgXpos = px;
    hgYpos = py;
    hgInMax = max;

    hgPos = 0;

    hgInBuff = (byte *)malloc(hgInMax + 4);
    hgInitStr(hgInBuff, hgInMax + 4);

    if (retn_str[0] != NULL) {
        memcpy(hgInBuff, retn_str, strlen(retn_str));
        for (i = strlen(retn_str); i < (hgInMax + 4); i++) hgInBuff[i] = 0;
    }

    if (hgSpcInMode) {
        hgEngAttr = hgREVERSE;
        hgHanAttr = hgREVERSE;
        hgPos = hgBufLen(hgInBuff);
        if (hgPos >= hgInMax - 1) hgPos = hgInMax - 1;
    }

    hgOverPutsPXy(hgXpos, hgYpos, hgInBuff);

    if (hgSpcInMode) {
        hgEngAttr = saveeng;
        hgHanAttr = savehan;
        ishan = hgTRUE;
    }

    hgInitCode();
    ext = (int *)hgGetExtKey();

    while (1) {
        hgSetCursor(CursREVERSE);
        hgSetTimerZero();
        reversemode = hgTRUE;
        do {
            saveticks = hgGetTimerTicks();
            if ((saveticks > hgCursorRate) && (hgCursorRate != 0)) {
                reversemode = !reversemode;
                if (reversemode) hgSetCursor(CursREVERSE);
                else hgSetCursor(CursNORMAL);
                hgSetTimerZero();
            }
            internal_routine();
            ch = inkey(hgNOWAIT);
            hgSaveCh = ch;
            internal_routine();
        } while (ch == hgNOKEY);
        hgSetCursor(CursNORMAL);

        extflag = -1;

        for (i = 0; i < hgGetNumExtKey(); i++)
            if (ext[i] == ch) proc_return(), extflag = _EXIT_KEYCODE;

        if (extflag != _EXIT_KEYCODE) {
            modesave = hgHanMode;
            extflag = proc_key(ch);
            if ((extflag == _SPECIAL_KEYCODE) && (modesave == hgHanMode) && (ch == SPACE) && ishan) {
                hgInitStr(hgInBuff, max + 4);
                hgBoxFillPXy(hgXpos, hgYpos, hgXpos + (max - 1) * 8 + 7, hgYpos + 15, hgBackColor);
                ishan = hgFALSE;
                hgPos = 0;
                proc_english(' ');
            }
            if (((extflag == _SPECIAL_KEYCODE) && ishan && (ch != SPACE))) {
                hgOverPutsPXy(hgXpos, hgYpos, hgInBuff);
                ishan = hgFALSE;
            }
        }

        if (extflag == _EXIT_KEYCODE) {
            if (ishan) {
                hgOverPutsPXy(hgXpos, hgYpos, hgInBuff);
                ishan = hgFALSE;
            }
            internal_routine();
            i2 = hgBufLen(hgInBuff);
            for (i = 0; i <= i2; i++) retn_str[i] = hgInBuff[i];
            retn_str[i] = 0;
            free(hgInBuff);
            hgXFactor = xfac;
            hgYFactor = yfac;
            return ch;
        }
        if (extflag == _NORMAL_KEYCODE) {
            if (ishan) {
                hgInitStr(hgInBuff, max + 4);
                hgBoxFillPXy(hgXpos, hgYpos, hgXpos + (max - 1) * 8 + 7, hgYpos + 15, hgBackColor);
                ishan = hgFALSE;
                hgPos = 0;
            }
            if ((ch >= 32) && (ch <= 255)) {
                if (!hgEngInMode && !hgDigitInMode) {
                    proc_hanin2(ch);
                } else if (hgEngInMode) {
                    proc_english(ch);
                } else if ((ch >= '0') && (ch <= '9')) {
                    proc_english(ch);
                }
            }
        }
    }
}

void hgRegisterKeyFunction(int keyvalue, void (*kf)(void))
{
    if (hgKeyNum >= MAXKEYFUNC) return;
    hgKeys[hgKeyNum] = keyvalue;
    hgKeyFunc[hgKeyNum] = kf;
    hgKeyNum++;
}


/* ------------------------------------------------------------------------ */

void proc_english(int ch)
{
    byte temp[2];

    hgSetCursor(CursNORMAL);
    if (hgHanMode) {
        if (!hgIsComplete()) {
            hgComplete2();
            if (hgPos >= hgInMax) hgPos -= 2;
        }
    }
    if (hgInsFlag) {
        if (hgBufLen(hgInBuff) < hgInMax) proc_ins(1);
        else return;
    }
    if (!isascii(hgInBuff[hgPos])) hgInBuff[hgPos + 1] = SPACE;
    hgInBuff[hgPos] = ch;

    temp[0] = ch;
    temp[1] = 0;

    if (hgInsFlag) hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, &hgInBuff[hgPos]);
    else hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, temp);

    if (hgPos < (hgInMax - 1)) hgPos++;
}

void proc_hanin2(int ch)
{
    byte bios;

    if (hgHanMode && isalpha(ch)){
        if (hgPos == hgInMax - 1) return;
        if (hgIsComplete() && hgInsFlag) {
            if (hgBufLen(hgInBuff) < hgInMax) proc_ins(2);
            else return;
        }
        bios = bioskey(2);
        bios &= 0x7f;
        if ((bios & LEFT_SHIFT) || (bios & RIGHT_SHIFT))
            hgHcode = hgKeyShifted[toupper(ch) - 'A'];
        else
            hgHcode = hgKey[toupper(ch) - 'A'];
        if (hgHcode > MID_OFF) proc_hanin2_mo();
        else proc_hanin2_ja();
        hgOutputNew();
    } else {
        proc_english(ch);
    }
}

void proc_hanin2_ja(void)
{
    int temp;

    if ((hanin.c.firc == EMPTY) && (hanin.c.midc == EMPTY2)) {
        hanin.c.firc = hgHcode;
    } else if ((hanin.c.firc != EMPTY) && (hanin.c.midc == EMPTY2)) {
        hgComplete();
        hanin.c.firc = hgHcode;
    } else if (hanin.c.midc != EMPTY2) {
        if (hanin.c.lasc == EMPTY) {
            if ((temp = proc_hanin2_last_by_first(hgHcode)) != NO_CODE) {
                hanin.c.lasc = temp;
            } else {
                hgComplete();
                hanin.c.firc = hgHcode;
            }
        } else if ((temp = proc_hanin2_last2_find()) == NO_CODE) {
            hgComplete();
            hanin.c.firc = hgHcode;
        } else hanin.c.lasc = temp;
    }
}

void proc_hanin2_mo(void)
{
    int temp;

    hgHcode -= MID_OFF;

    if (hanin.c.lasc != EMPTY) {
        if ((temp = proc_hanin2_last2_find_mo()) == NO_CODE) {
            temp = proc_hanin2_first_by_last(hanin.c.lasc);
            hanin.c.lasc = EMPTY;
            hgComplete();
            hanin.c.firc = temp;
            hanin.c.midc = hgHcode;
        } else {
            hgComplete();
            hanin.c.firc = temp;
            hanin.c.midc = hgHcode;
        }
    } else if (hanin.c.midc == EMPTY2) {
        hanin.c.midc = hgHcode;
    } else {
        if ((temp = proc_hanin_middle2_find()) == NO_CODE) {
            hgComplete();
            hanin.c.midc = hgHcode;
        } else hanin.c.midc = temp;
    }
}

byte proc_hanin2_first_by_last(int code)
{
    int i;

    for (i = 0; i < 16; i++)
        if (*(hgFirstLast + i * 2 + 1) == code) return *(hgFirstLast + i * 2);

    return NO_CODE;
}

byte proc_hanin2_last_by_first(int code)
{
    int i;

    for (i = 0; i < 16;i++)
        if (*(hgFirstLast + i * 2) == code) return *(hgFirstLast + i * 2 + 1);

    return NO_CODE;
}

byte proc_hanin2_last2_find(void)
{
    int i;

    for (i = 0; i < 11; i++)
        if (*(hgLast2 + i * 3) == hanin.c.lasc && *(hgLast2 + i * 3 + 1) == hgHcode)
            return *(hgLast2 + i * 3 + 2);

    return NO_CODE;
}

byte proc_hanin2_last2_find_mo(void)
{
    int i;

    for (i = 0; i < 11; i++) {
        if (*(hgLast2 + i * 3 + 2) == hanin.c.lasc) {
            hanin.c.lasc = *(hgLast2 + i * 3);
            return *(hgLast2 + i * 3 + 1);
        }
    }

    return NO_CODE;
}

byte proc_hanin_middle2_find(void)
{
    int i;

    for (i = 0; i < 7; i++)
        if (*(hgMiddle2 + i * 3) == hanin.c.midc && *(hgMiddle2 + i * 3 + 1) == hgHcode)
            return *(hgMiddle2 + i * 3 + 2);

    return NO_CODE;
}

byte proc_hanin_middle2_find_mo(void)
{
    int i;

    for (i = 0; i < 7; i++)
        if (*(hgMiddle2 + i * 3 + 2) == hanin.c.midc) {
            hanin.c.midc = *(hgMiddle2 + i * 3);
            return *(hgMiddle2 + i * 3 + 1);
        }

    return NO_CODE;
}


/* ------------------------------------------------------------------------ */

int proc_key(int ch)
{
    int ret_flag = _NORMAL_KEYCODE;
    int i, *dis;

    dis = (int *)hgGetDisableKey();

    for (i = 0; i < hgGetNumDisableKey(); i++)
        if (dis[i] == ch) return _DISABLE_KEYCODE;

    for (i = hgKeyNum - 1; i >= 0; i--)
        if (hgKeys[i] == ch) {
            (*hgKeyFunc[i])();
            ret_flag = _SPECIAL_KEYCODE;
            break;
        }
    if ((ch == RETURN) || (ch == ESC)) ret_flag = _EXIT_KEYCODE;
    return ret_flag;
}

void proc_left(void)
{
    if (hgPos <= 0) return;
    hgSetCursor(CursNORMAL);
    if (!hgIsComplete()) {
        hgComplete2();
        hgPos -= 2;
    }
    if (hgIsHangul()) hgPos -= 2;
    else hgPos--;
}

void proc_right(void)
{
    if (hgPos >= hgInMax - 2 + isascii(hgInBuff[hgPos])) return;
    if (hgInBuff[hgPos] == 0) return;   /**/
    hgSetCursor(CursNORMAL);
    if (!hgIsComplete()) {
        hgComplete2();
        hgPos -= 2;
    }
    if (isascii(hgInBuff[hgPos])) hgPos++;
    else hgPos += 2;
    /*
    if (hgInBuff[hgPos] == 0) hgInBuff[hgPos] = 0x20;
    */
}

void proc_ctrlleft(void)
{
    while (1) {
        if (hgPos <= 0) return;
        proc_left();
        if (hgInBuff[hgPos] == ' ') break;
    }
    proc_right();
}

void proc_ctrlright(void)
{
    while (1) {
        if (hgPos >= hgInMax - 2 + isascii(hgInBuff[hgPos])) return;
        proc_right();
        if (hgInBuff[hgPos] == ' ') break;
        if (hgInBuff[hgPos] == 0) break;
    }
    proc_left();
}

void proc_del(void)
{
    int l, i;

    l = hgBufLen(hgInBuff);

    if (hgPos >= l) return;
    if (!hgIsComplete()) {
        hgComplete2();
        hgPos -= 2;
    }
    if (isascii(hgInBuff[hgPos])) {
        for (i = hgPos + 1; i <= l - 1; i++) hgInBuff[i - 1] = hgInBuff[i];
        for (i = l - 1; i < hgInMax + 4; i++) hgInBuff[i] = 0;
        hgOverPutsPXy(hgXpos + (l - 1) * 8, hgYpos, " ");
        hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, " ");
    } else {
        for (i = hgPos + 2; i <= l - 1; i++) hgInBuff[i - 2] = hgInBuff[i];
        for (i = l - 2; i < hgInMax + 4; i++) hgInBuff[i] = 0;
        hgOverPutsPXy(hgXpos + (l - 2) * 8, hgYpos, "  ");
        hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, "  ");
    }
    hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, &hgInBuff[hgPos]);
}

void proc_end(void)
{
    hgSetCursor(CursNORMAL);
    if (!hgIsComplete()) hgComplete2();
    hgPos = hgBufLen(hgInBuff);
    if (hgPos >= hgInMax - 1) {
        int i, save = 0;
        for (i = 0; i < hgBufLen(hgInBuff); ) {
            save = i;
            if (hgInBuff[i] & 0x80) i += 2;
            else i++;
        }
        hgPos = save;
    }
}

void proc_home(void)
{
    hgSetCursor(CursNORMAL);
    if (!hgIsComplete()) hgComplete2();
    hgPos = 0;
}

void proc_bs(void)
{
    hgSetCursor(CursNORMAL);
    if (hgIsComplete()) {
        if (hgPos <= 0) return;
        if (!hgIsHangul()) {
            hgPos--;
            proc_del();
        } else {
            hgPos -= 2;
            proc_del();
        }
    } else {
        if (hanin.c.lasc != EMPTY) {
            if (proc_hanin2_last2_find_mo() == NO_CODE) hanin.c.lasc = EMPTY;
        } else if (hanin.c.midc != EMPTY2) {
            if (proc_hanin_middle2_find_mo() == NO_CODE) hanin.c.midc = EMPTY2;
        } else if (hanin.c.firc != EMPTY) hanin.c.firc = EMPTY;
        if (hgIsComplete()) {
            proc_del();
            goto bs_next;
        }
        hgInBuff[hgPos] = hanin.b.fchar;
        hgInBuff[hgPos + 1] = hanin.b.schar;
bs_next:
        hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, &hgInBuff[hgPos]);
        hgSetCursor(CursREVERSE);
    }
}

void proc_ins(int n)
{
    int i, l;

    l = hgBufLen(hgInBuff);

    if (n == 1) {
        for (i = l - 1; i >= hgPos; i--) hgInBuff[i + 1] = hgInBuff[i];
        hgInBuff[hgPos] = SPACE;
    } else {
        for (i = l - 1; i >= hgPos; i--) hgInBuff[i + 2] = hgInBuff[i];
        hgInBuff[hgPos] = SPACE;
        hgInBuff[hgPos + 1] = SPACE;
    }
}

void proc_insflag(void)
{
    hgSetCursor(CursNORMAL);
    hgInsFlag = 1 - hgInsFlag;
    if (!hgIsComplete()) {
        hgComplete2();
        if (hgPos >= hgInMax) hgPos -= 2;
    }
}

void proc_return(void)
{
    int l, i;

    hgSetCursor(CursNORMAL);
    if (!hgIsComplete()) hgComplete2();

    /* closeStr(); */

    l = hgBufLen(hgInBuff);
    hgInBuff[l] = 0;
    for (i = 0; i <= l - 1; i++)
        if (hgInBuff[i] == 0) hgInBuff[i] = 0x20;
}

void proc_space(void)
{
    byte bios;

    hgSetCursor(CursNORMAL);
    bios = bioskey(2);
    bios &= 0x7f;
    if (!hgIsComplete()) {
        hgComplete2();
        if (hgPos >= hgInMax) hgPos -= 2;
    }
    if ((bios & LEFT_SHIFT) || (bios & RIGHT_SHIFT)) hgHanMode = !hgHanMode;
    else proc_english(' ');
}


/* ------------------------------------------------------------------------ */

int hgBufLen(byte *str)
{
    int i;

    for (i = hgInMax; i >= 0; i--)
        if (str[i] != 0) return (i + 1);

    return 0;
}

int hgIsHangul(void)
{
    int ret_mode, i;

    for (i = 0; i < hgPos; ) {
        if (isascii(hgInBuff[i])) ret_mode = OFF0, i++;
        else ret_mode = OFF2, i += 2;
    }

    return ret_mode;
}

int hgIsComplete(void)
{
    if ((hanin.c.firc + hanin.c.midc + hanin.c.lasc) != 4) return OFF0;
    return OFF2;
}

void hgComplete(void)
{
    hgSetCursor(CursNORMAL);
    hanin.c.dummy = 1;
    hgInBuff[hgPos++] = hanin.b.fchar;
    hgInBuff[hgPos++] = hanin.b.schar;
    hgInitCode();
    if (hgInsFlag) {
        if (hgBufLen(hgInBuff) < hgInMax) proc_ins(2);
        else hgPos -= 2;
    } else {
        if (hgPos >= hgInMax - 1) hgPos -= 2;
    }
}

void hgComplete2(void)
{
    hgSetCursor(CursNORMAL);
    hanin.c.dummy = 1;
    hgInBuff[hgPos++] = hanin.b.fchar;
    hgInBuff[hgPos++] = hanin.b.schar;
    hgInitCode();
}

void hgInitCode(void)
{
    hanin.c.firc = 1;
    hanin.c.midc = 2;
    hanin.c.lasc = 1;
    hanin.c.dummy = 0;
}


/* ------------------------------------------------------------------------ */

void hgOutputNew(void)
{
    int i, i2, tpos;
    byte temp[4];

    if (!hgInsFlag)
        if (isascii(hgInBuff[hgPos]) && (hgInBuff[hgPos + 1] & 0x80))
            hgInBuff[hgPos + 2] = SPACE;

    hanin.c.dummy = 1;
    hgInBuff[hgPos] = hanin.b.fchar;
    hgInBuff[hgPos + 1] = hanin.b.schar;

    i2 = hgIsHangul();
    tpos = (hgPos > 2) ? hgPos - i2 : 0;
    if ((i2 != 0) && (hgPos >= 1)) {
        for (i = 0; i < i2; i++) temp[i] = hgInBuff[tpos + i];
        temp[i] = 0;
        hgOverPutsPXy(hgXpos + tpos * 8, hgYpos, temp);
    }
    if (hgInsFlag) {
        if (hgPos + 2 < hgInMax)
            hgOverPutsPXy(hgXpos + (hgPos + 2) * 8, hgYpos, &hgInBuff[hgPos + 2]);
    } else {
        temp[0] = hgInBuff[hgPos];
        temp[1] = hgInBuff[hgPos + 1];
        if (hgInBuff[hgPos + 2] == ' ') temp[2] = hgInBuff[hgPos + 2];
        else temp[2] = 0;
        temp[3] = 0;
        hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, temp);
    }
}

void hgSetCursor(int attribute)
{
    byte save, temp[3];
    byte attr_temp1, attr_temp2;
    byte engattr = 0, hanattr = 0;

    save = hgForeColor;

    if (isascii(hgInBuff[hgPos])) {
        temp[0] = hgInBuff[hgPos];
        temp[1] = 0;
        if (hgInBuff[hgPos] == 0) temp[0] = ' ';
    } else {
        temp[0] = hgInBuff[hgPos];
        temp[1] = hgInBuff[hgPos + 1];
        temp[2] = 0;
    }
    if (attribute == CursREVERSE){
        attr_temp1 = hgEngAttr;
        attr_temp2 = hgHanAttr;
        engattr = hanattr = hgCursorAttr;
        if (temp[0] == 0x20 && !(hgCursorAttr & hgUNDER))
            engattr = hgREVERSE, hanattr = hgREVERSE;
        hgForeColor = hgCursorColor;
        hgEngAttr = engattr;
        hgHanAttr = hanattr;
    }
    hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, temp);
    if (attribute == CursREVERSE) {
        hgForeColor = save;
        hgEngAttr = attr_temp1;
        hgHanAttr = attr_temp2;
    }
}

