/*
**      a  w : hanjain.c
**       I w : ea b 
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


void hgInitHanjaIn(int keyvalue)
{
    if (!hgHanjaOkFlag) return;
    hgRegisterKeyFunction(keyvalue, &proc_hanjain);
}

void hgHanjaToHangul(byte *src, byte *dest)
{
    int i;
    byte h1, h2;

    for (i = 0; i < strlen(src); ) {
        if (ishanja(src, i)) {
            hgHanjaToHangulSub(src[i], src[i + 1], &h1, &h2);
            dest[i] = h1;
            dest[i + 1] = h2;
            i += 2;
        } else  {
            dest[i] = src[i];
            i++;
        }
    }
    dest[i] = 0;
}

void hgHanjaToHangulSub(byte h1, byte h2, byte *hh1, byte *hh2)
{
    int off;
    int i;

    if ((h1 >= 0xe0 && h1 <= 0xfa) && ((h2 >= 0x31 && h2 <= 0x7e) || (h2 >= 0x91 && h2 <= 0xfe))) {
        if (h2 > 0x90) h2 -= 0x12;
        h2 -= 0x31;
        off = ((h1 - 0xe0) * 188 + h2);
    } else {
        *hh1 = h1;
        *hh2 = h2;
        return;
    }
    for (i = 0; i < 473; i++)
        if (hgHanjaTable[i][2] > off) break;
    i--;
    *hh1 = hgHanjaTable[i][0] / 256;
    *hh2 = hgHanjaTable[i][0] % 256;
}

void proc_hanjain(void)
{
    int h1, h2, i, comp, findflag = 0;
    int hc1, hc2, hanjacode, retflag, x, y, savecolor;
    byte *items[_MAXDIR], ret[10], hb1, hb2;
    hgHDIRBOX *p;
    hgWIDTH w = {280, 178};

    x = (hgGetx2r() + hgGetx1r()) / 2 - w.xwidth / 2;
    y = (hgGety2r() + hgGety1r()) / 2 - w.ywidth / 2;

    h1 = hgInBuff[hgPos];
    h2 = hgInBuff[hgPos + 1];

    comp = h1 * 256 + h2;

    for (i = 0; i < 473; i++) {
        if (hgHanjaTable[i][0] == comp) {
            findflag = 1;
            break;
        }
    }
    if (!findflag) {
        if (ishanja(hgInBuff, hgPos)) {
            hgHanjaToHangulSub(hgInBuff[hgPos], hgInBuff[hgPos + 1], &hb1, &hb2);
            hgInBuff[hgPos] = hb1;
            hgInBuff[hgPos + 1] = hb2;

            ret[0] = hb1;
            ret[1] = hb2;
            ret[2] = 0;

            hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, ret);
            hgPos += 2;
            if (hgPos >= hgInMax) hgPos = hgInMax - 2;
        }
        return;
    }
    for (retflag = 0; retflag < hgHanjaTable[i][1]; retflag++) {
        hanjacode = hgHanjaTable[i][2] + retflag;
        hc1 = (hanjacode / 188) + 0xe0;
        hc2 = (hanjacode % 188);
        if (hc2 < 78) hc2 += 0x31;
        else hc2 = hc2 - 78 + 0x91;
        items[retflag] = (byte *)malloc(3);
        items[retflag][0] = (byte)hc1;
        items[retflag][1] = (byte)hc2;
        items[retflag][2] = 0;
    }
    items[retflag] = (byte *)malloc(3);

    items[retflag][0] = 0;
    items[retflag][1] = 0;
    items[retflag][2] = 0;

    /**/

    savecolor = hgForeColor;
    hgForeColor = hgBLACK;

    hgSetSaveON();
    p = hgHDIRBOX_Load(items, w, 8, 6);
    hgHDIRBOX_Choose(p, x, y, "eab", ret);
    hgHDIRBOX_Free(&p);
    if (!hgIsComplete()) {
        hgComplete2();
        hgPos -= 2;
    }
    hgSetSaveOFF();
    hgRestore();

    hgForeColor = savecolor;

    /**/


    if (!strcmp(ret, "")) {
        hgPos += 2;
        if (hgPos >= hgInMax) hgPos = hgInMax - 2;
        return;
    }

    hgInBuff[hgPos] = ret[0];
    hgInBuff[hgPos + 1] = ret[1];

    for (retflag = 0; retflag <= hgHanjaTable[i][1]; retflag++)
        free(items[retflag]);

    hgOverPutsPXy(hgXpos + hgPos * 8, hgYpos, ret);
    hgPos += 2;
    if (hgPos >= hgInMax) hgPos = hgInMax - 2;
}

