/*
**      a  w : attr.c
**       I w : b b  ១
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


byte hgAttr    = hgNORMAL;
byte hgHanAttr = hgNORMAL;
byte hgEngAttr = hgNORMAL;
byte hgExtAttr = hgNORMAL;

void (*afunc[7])(byte *dest, int bytes) = {
    proc_REVERSE,
    proc_DIM,
    proc_SHADOW,
    proc_THREED,
    proc_OUTLINE,
    proc_BOLD,
    proc_UNDER,
};


byte hgGetAttr(void)
{
    return hgAttr;
}

void hgSetAttr(byte attr)
{
    hgHanAttr = attr;
    hgEngAttr = attr;
    hgAttr = attr;
}

byte hgGetHanAttr(void)
{
    return hgHanAttr;
}

void hgSetHanAttr(byte attr)
{
    hgHanAttr = attr;
}

byte hgGetEngAttr(void)
{
    return hgEngAttr;
}

void hgSetEngAttr(byte attr)
{
    hgEngAttr = attr;
}

byte hgGetExtAttr(void)
{
    return hgExtAttr;
}

void hgSetExtAttr(byte attr)
{
    hgExtAttr = attr;
}

void hgDoAttr(byte *dest, int bytes, int n)
{
    (*afunc[n])(dest, bytes);
}


/* ------------------------------------------------------------------------ */

void proc_REVERSE(byte *dest, int bytes)
{
    __asm__ __volatile__("
        movl %1, %%ecx
        movl %0, %%ebx

        shrl $2, %%ecx
reverse__loop:
        notl (%%ebx)
        addl $4, %%ebx
        loop reverse__loop
        "
        :
        : "g" (dest), "g" (bytes)
        : "bx", "cx", "memory"
    );
}

void proc_DIM(byte *dest, int bytes)
{
    __asm__ __volatile__("
        movl %0, %%ebx
        movl %1, %%esi
        cmpl $32, %%esi
        jz proc_DIM__shan1

proc_DIM__shlop1:

        andw $0xaa55, -2(%%ebx, %%esi)
        decl %%esi
        decl %%esi
        jne proc_DIM__shlop1
        jmp proc_DIM__quit

proc_DIM__shan1:

        andw $0xaaaa, -2(%%ebx, %%esi)
        decl %%esi
        decl %%esi
        andw $0x5555, -2(%%ebx, %%esi)
        decl %%esi
        decl %%esi
        jne proc_DIM__shan1

        jmp proc_DIM__quit

proc_DIM__quit:
        "
        :
        : "g" (dest), "g" (bytes)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );
}

void proc_SHADOW(byte *dest, int bytes)
{
    __asm__ __volatile__("
        movl %0, %%ebx
        movl %1, %%esi

        cmpl $32, %%esi
        jz proc_SHADOW__shan1

proc_SHADOW__shlop1:

        orw $0xaa55, -2(%%ebx, %%esi)
        decl %%esi
        decl %%esi
        jne proc_SHADOW__shlop1

        jmp proc_SHADOW__quit

proc_SHADOW__shan1:

        orw $0xaaaa, -2(%%ebx, %%esi)
        decl %%esi
        decl %%esi
        orw $0x5555, -2(%%ebx, %%esi)
        decl %%esi
        decl %%esi
        jne proc_SHADOW__shan1

proc_SHADOW__quit:
        "
        :
        : "g" (dest), "g" (bytes)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );
}

void proc_THREED(byte *dest, int bytes)
{
    byte temp1[32], temp2[32];

    memcpy(temp1, dest, bytes);
    memcpy(temp2, dest, bytes);

    __asm__ __volatile__("
        cmpl $16, %1
        jne proc_THREED__byte32
        movl $15, %%ecx
        movl %2, %%ebx
        movl %3, %%esi

proc_THREED__thlp1:

        movb (%%esi), %%ah
        orb %%ah, 1(%%ebx)
        shrb $1, %%ah
        orb %%ah, (%%ebx)
        shlb $1, %%ah
        xorb %%ah, (%%ebx)
        incl %%ebx
        incl %%esi
        loop proc_THREED__thlp1

        jmp proc_THREED__quit

proc_THREED__byte32:

        movl $16, %%ecx
        movl %2, %%ebx
        movl %3, %%esi

proc_THREED__thlp4:

        movw (%%esi), %%ax
        orw %%ax, 2(%%ebx)
        shrw $1, %%ax
        orw %%ax, (%%ebx)
        shlw $1, %%ax
        xorw %%ax, (%%ebx)
        incl %%ebx
        incl %%ebx
        incl %%esi
        incl %%esi
        loop proc_THREED__thlp4

proc_THREED__quit:
        "
        :
        : "g" (dest), "g" (bytes), "g" (temp1), "g" (temp2)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    memcpy(dest, temp1, bytes);
}

void proc_OUTLINE(byte *dest, int bytes)
{
    byte temp1[32], temp2[32];

    memcpy(temp1, dest, bytes);
    memcpy(temp2, dest, bytes);

    __asm__ __volatile__("
        movl %1, %%ecx
        movl %2, %%ebx
        movl %3, %%esi

        shrl $1, %%ecx

proc_OUTLINE__outlp1:

        movw (%%esi), %%ax
        shrw $1, %%ax
        orw %%ax, (%%ebx)
        shlw $2, %%ax
        orw %%ax, (%%ebx)
        incl %%ebx
        incl %%ebx
        incl %%esi
        incl %%esi
        loop proc_OUTLINE__outlp1

        cmpl $16, %1
        jne proc_OUTLINE__byte32

        movl $15, %%ecx
        movl %2, %%ebx
        movl %3, %%esi

proc_OUTLINE__outlp2:

        movb (%%esi), %%ah
        orb %%ah, 1(%%ebx)
        movb 1(%%esi), %%ah
        orb %%ah, (%%ebx)
        movb (%%esi), %%ah
        xorb %%ah, (%%ebx)
        incl %%ebx
        incl %%esi
        loop proc_OUTLINE__outlp2

        jmp proc_OUTLINE__quit

proc_OUTLINE__byte32:

        movl $15, %%ecx
        movl %2, %%ebx
        movl %3, %%esi

proc_OUTLINE__outlp4:

        movw (%%esi), %%ax
        orw %%ax, 2(%%ebx)
        movw 2(%%esi), %%ax
        orw %%ax, (%%ebx)
        movw (%%esi), %%ax
        xorw %%ax, (%%ebx)
        incl %%ebx
        incl %%ebx
        incl %%esi
        incl %%esi
        loop proc_OUTLINE__outlp4

proc_OUTLINE__quit:
        "
        :
        : "g" (dest), "g" (bytes), "g" (temp1), "g" (temp2)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    memcpy(dest, temp1, bytes);
}

void proc_BOLD(byte *dest, int bytes)
{
    __asm__ __volatile__("
        movl %1, %%ecx
        movl %0, %%edi

proc_BOLD__loop:
        movb (%%edi), %%al
        shrb $1, %%al
        orb %%al, (%%edi)
        incl %%edi
        loop proc_BOLD__loop
        "
        :
        : "g" (dest), "g" (bytes)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );
}

void proc_UNDER(byte *dest, int bytes)
{
    __asm__ __volatile__("
        movl %1, %%esi
        movl %0, %%ebx

        movb $0xff, -1(%%ebx, %%esi)
        cmpl $32, %%esi
        jne UNDER__quit
        movb $0xff, -2(%%ebx, %%esi)
UNDER__quit:
        "
        :
        : "g" (dest), "g" (bytes)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );
}

