/*
**      a  w : extfont.c
**       I w : b a ş
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


ExtFont *hgOpenExtFont(byte *path, int xbyte, int ylen, byte *linkedin_font)
{
    FILE *fp;
    int fsize, fnum;
    ExtFont *p;
    
    p = (ExtFont *)malloc(sizeof(ExtFont));

    if (path != NULL && linkedin_font == NULL) {
        fp = fopen(path, "rb");
        if (fp == NULL) return NULL;

        fseek(fp, 0, SEEK_END);
        fsize = ftell(fp);
        fnum = fsize / (xbyte * ylen);

        p->fp           = fp;
        p->xbyte        = xbyte;
        p->ylen         = ylen;
        p->fsize        = fsize;
        p->fnum         = fnum;
        p->buff         = (byte *)malloc(fsize);
        fseek(fp, 0, SEEK_SET);
        fread(p->buff, fsize, 1, fp);
        fclose(fp);
        p->is_linkedin  = 0;
    } else if ((path == NULL) && (linkedin_font != NULL)) {
        p->fp           = NULL;
        p->xbyte        = xbyte;
        p->ylen         = ylen;
        p->fsize        = -1;
        p->fnum         = -1;
        p->buff         = linkedin_font;
        p->is_linkedin  = 1;
    } else return NULL;

    return p;
}

void hgCloseExtFont(ExtFont *p)
{
    if (!(p->is_linkedin))
        fclose(p->fp), free(p->buff);

    free(p);
}

void hgPutExtFont(ExtFont *p, int px, int py, int num)
{
    int m = hgXFactor;
    int n = hgYFactor;
    int bytes = p->xbyte * p->ylen;
    int i, fac = 1;

    byte *mbuff, *nbuff, *buff;

    for (i = 1; i < m; i++) fac *= 2;

    mbuff = (byte *)malloc(bytes * fac);
    nbuff = (byte *)malloc(bytes * fac * n);
    buff  = (byte *)malloc(bytes);

    memcpy(buff, p->buff + (bytes * num), bytes);
    proc_attr(buff, -bytes);

    if (m != 1) widen(buff, mbuff, bytes);
    else memcpy(mbuff, buff, bytes);

    if (n != 1) lengthen(mbuff, nbuff, p->xbyte * fac, p->ylen);
    else memcpy(nbuff, mbuff, bytes * fac);

    putmag(px, py, nbuff, p->xbyte * fac, p->ylen * n, hgForeColor);

    free(mbuff), free(nbuff), free(buff);
}

