/*
**      a  w : font.c
**       I w : b i   w
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


/* 11520 = (5120) + (2816) + 3584() */

#define _FIR_SIZE       (8 * 20 * 32)   /* == 5120,  */
#define _MID_SIZE       (4 * 22 * 32)   /* == 2816,  */
#define _LAS_SIZE       (4 * 28 * 32)   /* == 3584,  */

#define _HANFONT_SIZE   (_FIR_SIZE + _MID_SIZE + _LAS_SIZE)
#define _ENGFONT_SIZE   (256 * 16)
#define _SPCFONT_SIZE   (128 * 32)


byte hanfont[_HANFONT_SIZE];
byte engfont[_ENGFONT_SIZE];
byte spcfont[_SPCFONT_SIZE];

byte hanfont_11008[_HANFONT_SIZE];


int hgLoadHanFont(byte *hanfile)
{
    int i, size, handle;

    handle = open(hanfile, O_RDONLY | O_BINARY);
    if (handle == -1) return hgFAIL;

    size = filelength(handle);
    if ((size != 11520) && (size != 11008)) return hgFAIL;

    if (size == 11008) {
        byte *p = hanfont;

        for (i = 0; i < 8; i++) {
            p += 32;
            read(handle, p, 19 * 32), p += (19 * 32);
        }
        for (i = 0; i < 4; i++) {
            p += 32;
            read(handle, p, 21 * 32), p += (21 * 32);
        }
        for (i = 0; i < 4; i++) {
            p += 32;
            read(handle, p, 27 * 32), p += (27 * 32);
        }
    } else read(handle, hanfont, _HANFONT_SIZE);

    close(handle);

    fir = hanfont;
    mid = hanfont + _FIR_SIZE;
    las = hanfont + _FIR_SIZE + _MID_SIZE;

    return hgSUCCESS;
}

int hgLoadEngFont(byte *engfile)
{
    int size, handle;

    handle = open(engfile, O_RDONLY | O_BINARY);
    if (handle == -1) return hgFAIL;

    size = filelength(handle);
    if ((size != _ENGFONT_SIZE) && (size != 2048)) return hgFAIL;

    read(handle, engfont, size);
    close(handle);

    eng = engfont;

    return hgSUCCESS;
}

int hgLoadSpcFont(byte *spcfile)
{
    int handle;

    handle = open(spcfile, O_RDONLY | O_BINARY);
    if (handle == -1) return hgFAIL;

    read(handle, spcfont, _SPCFONT_SIZE);
    close(handle);

    spc = spcfont;
    hgSpcEnableFlag = hgTRUE;

    return hgSUCCESS;
}


/* ------------------------------------------------------------------------ */

void hgSetHanFont(byte *linkedin_hanfont)
{
    int i;
    bool _11008 = hgFALSE;

    for (i = 0; i < 32; i++) {
        if (linkedin_hanfont[i] != 0) {
            _11008 = hgTRUE;
            break;
        }
    }

    if (_11008) {
        byte *src = linkedin_hanfont;
        byte *des = hanfont_11008;

        for (i = 0; i < 8; i++) {
            des += 32;
            memcpy(des, src, 19 * 32), src += (19 * 32);
            des += (19 * 32);
        }
        for (i = 0; i < 4; i++) {
            des += 32;
            memcpy(des, src, 21 * 32), src += (21 * 32);
            des += (21 * 32);
        }
        for (i = 0; i < 4; i++) {
            des += 32;
            memcpy(des, src, 27 * 32), src += (27 * 32);
            des += (27 * 32);
        }
        fir = hanfont_11008;
        mid = hanfont_11008 + _FIR_SIZE;
        las = hanfont_11008 + _FIR_SIZE + _MID_SIZE;
    } else {
        fir = linkedin_hanfont;
        mid = linkedin_hanfont + _FIR_SIZE;
        las = linkedin_hanfont + _FIR_SIZE + _MID_SIZE;
    }
}

void hgSetEngFont(byte *linkedin_engfont)
{
    eng = linkedin_engfont;
}

void hgSetSpcFont(byte *linkedin_spcfont)
{
    spc = linkedin_spcfont;

    hgSpcEnableFlag = hgTRUE;
}

