/*
**      a  w : hanout.c
**       I w : ei  w bi e  q e
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


byte *fir, *mid, *las, *eng, *spc;

HTYPE htypes = {8 * 20 * 32, 4 * 22 * 32, 4 * 28 * 32};
ETYPE etypes = {256 * 16};

union {
    hcode c;
    hchar b;
} han;


int _x_pos = 1;
int _y_pos = 1;
int _px_pos = 0;
int _py_pos = 0;

bool hgEngFlag          = hgFALSE;
bool hgSpcEnableFlag    = hgFALSE;
bool hgGraphOkFlag      = hgFALSE;
bool hgHanjaOkFlag      = hgFALSE;
bool hgTextAttrFlag     = hgFALSE;

void (*atps)(byte *str, int *pos) = &pos_null_function;
void (*grps)(byte *str, int pos) = &hanja_null_function;
void (*hjps)(byte *str, int pos) = &hanja_null_function;


int hgWhereX(void)
{
    return _x_pos;
}

int hgWhereY(void)
{
    return _y_pos;
}

void hgGotoXy(int x, int y)
{
    _x_pos = x;
    _y_pos = y;
}

void hgPuts(byte *str)
{
    byte temp[256];
    int i, s1_len = hgGetMaxX() - _x_pos + 1;

    if (strlen(str) >= s1_len) {
        strncpy(temp, str, s1_len);
        temp[s1_len] = 0;
        hgPutsXy(_x_pos, _y_pos, temp);
        _x_pos += strlen(str);
        _x_pos -= hgGetMaxX();
        if (_y_pos < hgGetMaxY()) _y_pos++;
        else hgScrUp(1, 1, hgGetMaxX(), hgGetMaxY(), 16, hgBackColor);
        for (i = 0; i < (strlen(str) - s1_len) / hgGetMaxX(); i++) {
            strncpy(temp, str + s1_len + hgGetMaxX() * i, hgGetMaxX());
            temp[hgGetMaxX()] = 0;
            hgPutsXy(1, _y_pos, temp);
            if (_y_pos < hgGetMaxY()) _y_pos++;
            else hgScrUp(1, 1, hgGetMaxX(), hgGetMaxY(), 16, hgBackColor);
        }
        hgPutsXy(1, _y_pos, str + s1_len + hgGetMaxX() * i);
    } else {
        hgPutsXy(_x_pos, _y_pos, str);
        _x_pos += strlen(str);
    }
}

void hgPutsXy(int x, int y, byte *str)
{
    hgPutsPXy(8 * (x - 1), 16 * (y - 1), str);
}

void hgPutsPXy(int px, int py, byte *str)
{
    int pos = 0;

    _px_pos = px;
    _py_pos = py;

    while (str[pos] != 0) {
        if (str[pos] == '/') {
            proc_textattr(str, &pos);
        } else if (str[pos] == '\t') {
            _px_pos = _px_pos + (8 - (_px_pos / 8) % 8) * 8;
            pos++;
        } else if (!(str[pos] & 0x80)) {
            proc_engout(str, pos);
            pos++;
        } else if (hgSpcEnableFlag && isspc(str, pos)) {
            proc_spcout(str, pos);
            pos += 2;
        } else if (hgGraphOkFlag && isgraphic(str, pos)) {
            proc_graphout(str, pos);
            pos += 2;
        } else if (hgHanjaOkFlag && ishanja(str, pos)) {
            proc_hanjaout(str, pos);
            pos += 2;
        } else {
            proc_hanout(str, pos);
            pos += 2;
        }
    }
}

void hgPrintf(byte *fmt, ...)
{
    byte s[255];

    va_list argptr;
    va_start(argptr, fmt);
    vsprintf(s, fmt, argptr);

    hgPuts(s);
}

void hgPrintfXy(int x, int y, byte *fmt, ...)
{
    byte s[255];

    va_list argptr;
    va_start(argptr, fmt);
    vsprintf(s, fmt, argptr);

    hgPutsXy(x, y, s);
}

void hgPrintfPXy(int px, int py, byte *fmt, ...)
{
    byte s[255];

    va_list argptr;
    va_start(argptr, fmt);
    vsprintf(s, fmt, argptr);

    hgPutsPXy(px, py, s);
}


/* ------------------------------------------------------------------------ */

void hanja_null_function(byte *str, int pos)
{
    proc_hanout(str, pos);
}

void pos_null_function(byte *str, int *pos)
{
    proc_engout(str, *pos), (*pos)++;
}

void proc_attr(byte *dest, int bytes)
{
    static byte attr;

    if (bytes == 16) attr = hgEngAttr;
    else if (bytes == 32) attr = hgHanAttr;
    else if (bytes < 0) {
        attr = hgExtAttr;
        bytes = -bytes;
    }

    if (attr == hgNORMAL) return;

    if (attr & hgREVERSE) hgDoAttr(dest, bytes, 0);
    if (attr & hgDIM    ) hgDoAttr(dest, bytes, 1);
    if (attr & hgSHADOW ) hgDoAttr(dest, bytes, 2);
    if (attr & hgTHREED ) hgDoAttr(dest, bytes, 3);
    if (attr & hgOUTLINE) hgDoAttr(dest, bytes, 4);
    if (attr & hgBOLD   ) hgDoAttr(dest, bytes, 5);
    if (attr & hgUNDER  ) hgDoAttr(dest, bytes, 6);
}

void proc_completehan(int mode, byte *dest, byte *src, int nums)
{
    __asm__ __volatile__("
        movl %3, %%ecx
        movl %1, %%edi
        movl %2, %%esi
        cmpl $1, %0
        jnz completehan__next2
        cld
        REP
        movsw

        jmp completehan__quit

completehan__next2:

        lodsw
        orw %%ax, (%%edi)
        incl %%edi
        incl %%edi
        loop completehan__next2

completehan__quit:
        "
        :
        : "g" (mode), "g" (dest), "g" (src), "g" (nums)
        : "ax", "cx", "si", "di", "memory"
    );
}

void proc_engout(byte *str, int pos)
{
    static byte ebuffer[16];

    hgEngFlag = hgTRUE;
    memcpy(ebuffer, eng + str[pos] * 16, 16);
    proc_attr(ebuffer, 16);

    puteng(_px_pos, _py_pos, ebuffer, hgForeColor);
    _px_pos += 8;
}

void proc_graphout(byte *str, int pos)
{
    (*grps)(str, pos);
}

void proc_hanjaout(byte *str, int pos)
{
    (*hjps)(str, pos);
}

void proc_hanout(byte *str, int pos)
{
    static int fcode, mcode, lcode;
    static int f1 = 0, f2 = 0, f3 = 0;
    static bool hflag;
    static byte hbuffer[32];

    han.b.fchar = str[pos];
    han.b.schar = str[pos + 1];

    fcode = code_table[0][han.c.firc];
    mcode = code_table[1][han.c.midc];
    lcode = code_table[2][han.c.lasc];

    f3 = Dml[mcode];
    f2 = Dfm[fcode * 2 + (lcode != 0)];
    f1 = Dmf[mcode * 2 + (lcode != 0)];

    hflag = hgTRUE;
    hgEngFlag = hgFALSE;

    if (fcode) {
        proc_completehan(0x01, hbuffer, fir + (f1 * 20 + fcode) * 32, 16);
        hflag = hgFALSE;
    }
    if (mcode) {
        proc_completehan(hflag, hbuffer, mid + (f2 * 22 + mcode) * 32, 16);
        hflag = hgFALSE;
    }
    if (lcode) {
        proc_completehan(hflag, hbuffer, las + (f3 * 28 + lcode) * 32, 16);
        hflag = hgFALSE;
    }

    proc_attr(hbuffer, 32);

    puthan(_px_pos, _py_pos, hbuffer, hgForeColor);
    _px_pos += 16;
}

void proc_spcout(byte *str, int pos)
{
    static byte sbuffer[32];

    memcpy(sbuffer, spc + (str[pos + 1] - 128) * 32, 32);
    proc_attr(sbuffer, 32);

    puthan(_px_pos, _py_pos, sbuffer, hgForeColor);
    _px_pos += 16;
}

void proc_textattr(byte *str, int *pos)
{
    (*atps)(str, pos);
}

int isgraphic(byte *str, int pos)
{
    static int i, fontID[] = {0xd480, 0xd931, 0xda31, 0xdb31, 0xdc31, 0xdd31, 0xde31};
    static byte hc1, hc2;

    for (i = 0; i < 7; i++) {
        hc1 = (fontID[i] >> 8) & 0xff;
        hc2 = (fontID[i] & 0xff);
        if ((str[pos] == hc1) && (str[pos + 1] >= hc2)) return hgSUCCESS;
    }
    return hgFAIL;
}

int ishanja(byte *str, int pos)
{
    static byte hc1, hc2;

    hc1 = str[pos];
    hc2 = str[pos + 1];

    if ((hc1 >= 0xe0 && hc1 <= 0xfa) && ((hc2 >= 0x31 && hc2 <= 0x7e) || (hc2 >= 0x91 && hc2 <= 0xfe)))
        return hgSUCCESS;
    else
        return hgFAIL;
}

int isspc(byte *str, int pos)
{
    const byte SPC_CODE = 212;

    if (str[pos] == SPC_CODE && str[pos] >= 0x80) return hgSUCCESS;
    else return hgFAIL;
}

