/*
**      a  w : putover.c
**       I w : wA ae(OVER_PUT) b q e
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


void hgOverPuts(byte *str)
{
    byte temp[256];
    int i, s1_len = hgGetMaxX() - _x_pos + 1;

    if (strlen(str) >= s1_len) {
        strncpy(temp, str, s1_len);
        temp[s1_len] = 0;
        hgOverPutsXy(_x_pos, _y_pos, temp);
        _x_pos += strlen(str);
        _x_pos -= hgGetMaxX();
        if (_y_pos < hgGetMaxY()) _y_pos++;
        else hgScrUp(1, 1, hgGetMaxX(), hgGetMaxY(), 16, hgBackColor);
        for (i = 0; i < (strlen(str) - s1_len) / hgGetMaxX(); i++) {
            strncpy(temp, str + s1_len + hgGetMaxX() * i, hgGetMaxX());
            temp[hgGetMaxX()] = 0;
            hgOverPutsXy(1, _y_pos, temp);
            if (_y_pos < hgGetMaxY()) _y_pos++;
            else hgScrUp(1, 1, hgGetMaxX(), hgGetMaxY(), 16, hgBackColor);
        }
        hgOverPutsXy(1, _y_pos, str + s1_len + hgGetMaxX() * i);
    } else {
        hgOverPutsXy(_x_pos, _y_pos, str);
        _x_pos += strlen(str);
    }
}

void hgOverPutsXy(int x, int y, byte *str)
{
    hgOverPutsPXy(8 * (x - 1), 16 * (y - 1), str);
}

void hgOverPutsPXy(int px, int py, byte *str)
{
    int i;
    byte temp[3];

    for (i = 0; i < strlen(str); ) {
        if (str[i] & 0x80) {
            temp[0] = str[i];
            temp[1] = str[i + 1];
            temp[2] = 0;
            erase_hangul(px + i * 8, py, hgBackColor);
            hgPutsPXy(px + i * 8, py, temp);
            i += 2;
        } else if (str[i] == '\n') {
            px = 0;
            py += 16;
            i++;
        } else if (str[i] == '\t') {
            px += (8 - (px / 8) % 8) * 8;
            i++;
        } else {
            temp[0] = str[i];
            temp[1] = 0;
            erase_english(px + i * 8, py, hgBackColor);
            hgPutsPXy(px + i * 8, py, temp);
            i++;
        }
    }
}

void hgOverPrintf(byte *fmt, ...)
{
    byte s[255];

    va_list argptr;
    va_start(argptr, fmt);
    vsprintf(s, fmt, argptr);

    hgOverPuts(s);
}

void hgOverPrintfXy(int x, int y, byte *fmt, ...)
{
    byte s[255];

    va_list argptr;
    va_start(argptr, fmt);
    vsprintf(s, fmt, argptr);

    hgOverPutsXy(x, y, s);
}

void hgOverPrintfPXy(int px, int py, byte *fmt, ...)
{
    byte s[255];

    va_list argptr;
    va_start(argptr, fmt);
    vsprintf(s, fmt, argptr);

    hgOverPutsPXy(px, py, s);
}


/* ------------------------------------------------------------------------ */

void erase_hangul(int px, int py, int color)
{
    static byte font[32] = {
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
    };

    puthan(px, py, font, color);
}

void erase_english(int px, int py, int color)
{
    static byte font[16] = {
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
    };

    puteng(px, py, font, color);
}

