/*
**      a  w : hvln16.c
**       I w : a, A u (16 a)
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


void hgHLine16(int px1, int px2, int py, byte color)
{
    int xs, xe;
    byte rmask, lmask;

    rmask = get_rmask(px2);
    lmask = get_lmask(px1);

    xs = px1 / 8 + 1;
    xe = px2 / 8 - 1;

    byteline(xs, xe, py, color);
    sideline(xs - 1, py, color, lmask);
    sideline(xe + 1, py, color, rmask);
}

void hgVLine16(int px, int py1, int py2, byte color)
{
    vertline(px >> 3, py1, py2, color, get_vmask(px));
}


/* ------------------------------------------------------------------------ */

void byteline(int tx1, int tx2, int py, byte color)
{
    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %3, %%ecx
        subl %2, %%ecx
        incl %%ecx

        movl %1, %%ebx
        movl %4, %%eax
        mulw %%bx
        addl %2, %%eax
        addl %0, %%eax
        addl $0xa0000, %%eax

        movl %%eax, %%edi

        movl $0x03ce, %%edx
        movl $0x0205, %%eax
        outw %%ax, %%dx
        movl $0xff08, %%eax
        outw %%ax, %%dx

        movb %5, %%al
        REP
        stosb

        movl $0x0005, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx1), "g" (tx2), "g" (py), "g" (color)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void sideline(int tx, int ty, byte color, byte mask)
{
    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %1, %%ebx
        movl %3, %%eax
        mulw %%bx
        addl %2, %%eax
        addl %0, %%eax
        addl $0xa0000, %%eax

        movl %%eax, %%edi

        movl $0x03ce, %%edx
        movl $0x0205, %%eax
        outw %%ax, %%dx
        movb $8, %%al
        movb %5, %%ah
        outw %%ax, %%dx

        movb %4, %%ah

        movb (%%edi), %%al
        movb %%ah, (%%edi)

        movl $0x0005, %%eax
        outw %%ax, %%dx
        movl $0xff08, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx), "g" (ty), "g" (color), "g" (mask)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void vertline(int tx, int py1, int py2, byte color, byte mask)
{
    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %4, %%ecx
        subl %3, %%ecx
        incl %%ecx

        movl %1, %%ebx
        movl %3, %%eax
        mulw %%bx
        addl %2, %%eax
        addl %0, %%eax
        addl $0xa0000, %%eax

        movl %%eax, %%edi

        movl $0x03ce, %%edx
        movl $0x0205, %%eax
        outw %%ax, %%dx
        movb $8, %%al
        movb %6, %%ah
        outw %%ax, %%dx

        movb %5, %%ah

vertline__loop:
        movb (%%edi), %%al
        movb %%ah, (%%edi)
        addl %1, %%edi
        loop vertline__loop

        movl $0x0005, %%eax
        outw %%ax, %%dx
        movl $0xff08, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx), "g" (py1), "g" (py2), "g" (color), "g" (mask)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

