/*
**      a  w : image16.c
**       I w :  w/ (16 a)
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


int hgImageSize16(int px1, int py1, int px2, int py2)
{
    int size;
    int xs = px1 / 8 + 1;
    int xe = px2 / 8 - 1;

    size = (xe - xs + 1) * (py2 - py1 + 1) * 4;
    size += ((py2 - py1 + 1) * 2 * 4);
    size += 2;

    return size;
}

void hgGetImage16(int px1, int py1, int px2, int py2, byte *buff)
{
    int xs = px1 / 8 + 1;
    int xe = px2 / 8 - 1;
    int offset;

    buff[0] = get_lmask(px1);
    buff[1] = get_rmask(px2);

    if (xs <= xe) {
        getimage16(xs, py1, xe, py2, buff + 2);
        offset = (py2 - py1 + 1) * (xe - xs + 1) * 4 + 2;
    } else offset = 2;

    getimage16(xs - 1, py1, xs - 1, py2, buff + offset);
    offset += (py2 - py1 + 1) * 4;
    getimage16(xe + 1, py1, xe + 1, py2, buff + offset);
}

void hgPutImage16(int px1, int py1, int px2, int py2, byte *buff)
{
    int xs = px1 / 8 + 1;
    int xe = px2 / 8 - 1;
    int offset;
    byte lmask, rmask;

    lmask = buff[0];
    rmask = buff[1];

    if (xs <= xe) {
        putimage16(xs, py1, xe, py2, buff + 2);
        offset = (py2 - py1 + 1) * (xe - xs + 1) * 4 + 2;
    } else offset = 2;

    outportb(0x3ce, 8);
    outportb(0x3cf, lmask);

    putimage16(xs - 1, py1, xs - 1, py2, buff + offset);

    offset += ((py2 - py1 + 1) * 4);

    outportb(0x3ce, 8);
    outportb(0x3cf, rmask);

    putimage16(xe + 1, py1, xe + 1, py2, buff + offset);

    outportw(0x3ce, 0xff08);
}


/* ------------------------------------------------------------------------ */

void getimage16(int tx1, int py1, int tx2, int py2, byte *buff)
{
    int y_width = py2 - py1 + 1;
    int x_width = tx2 - tx1 + 1;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %2, %%edi              /* edi = buff */

        movl %4, %%eax
        imull %1, %%eax
        addl %3, %%eax              /* eax = py1 * hgXbyte + tx1 */
        addl $0xa0000, %%eax        /* eax =  A   */
        addl %0, %%eax              /* eax = __djgpp_conventional_base  */

        movl %%eax, %%ebx           /* ebx = A aU */

        movl %6, %%ecx              /* ecx = y_width (A e U) */

getimage16__g1:
        pushl %%ecx
        movb $3, %%ah

getimage16__g2:
        movb $4, %%al
        movl $0x03ce, %%edx
        outw %%ax, %%dx
        movl %%ebx, %%esi

        movl %5, %%ecx
        cld
        REP
        movsb

        decb %%ah
        jns getimage16__g2
        addl %1, %%ebx
        popl %%ecx
        loop getimage16__g1

        movl $0x0f04, %%eax
        movl $0x03ce, %%edx
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte), "g" (buff),
          "g" (tx1), "g" (py1), "g" (x_width), "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void putimage16(int tx1, int py1, int tx2, int py2, byte *buff)
{
    int x_width = tx2 - tx1 + 1;
    int y_width = py2 - py1 + 1;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl $0x03ce, %%edx
        movl $5, %%eax
        outw %%ax, %%dx

        movl %4, %%eax
        imull %1, %%eax
        addl %3, %%eax              /* eax = py1 * hgXbyte + tx1 */
        addl $0xa0000, %%eax        /* eax =  A   */
        addl %0, %%eax              /* eax = __djgpp_conventional_base  */

        movl %%eax, %%ebx           /* ebx = A aU */
        movl %2, %%esi              /* esi = buff  */

        movl %6, %%ecx              /* ecx = y_width (A e U) */
putimage16__p1:
        movb $8, %%ah

        pushl %%ecx
putimage16__p2:

        movb $2, %%al
        movl $0x03c4, %%edx
        outw %%ax, %%dx

        movl %5, %%ecx              /* ecx = x_width; (a e U) */
        movl %%ebx, %%edi
        cld
putimage16__movsb:
        movb (%%edi), %%al     /* áA q */
        movsb
        loop putimage16__movsb
        shrb $1, %%ah
        jnc putimage16__p2
        addl %1, %%ebx              /* aU  (aq ) */
        popl %%ecx
        loop putimage16__p1

        movl $0x03c4, %%edx
        movl $0x0f02, %%eax
        outw %%ax, %%dx

        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte), "g" (buff),
          "g" (tx1), "g" (py1), "g" (x_width), "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

