/*
**      a  w : image256.c
**       I w :  w/ (256 a)
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


int hgImageSize256(int px1, int py1, int px2, int py2)
{
    return ((px2 - px1 + 1) * (py2 - py1 + 1));
}

void hgGetImage256(int px1, int py1, int px2, int py2, byte *buff)
{
    int x_width = px2 - px1 + 1;
    int y_width = py2 - py1 + 1;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %3, %%eax
        movl %1, %%ebx
        mulw %%bx
        addw %2, %%ax
        adcl $0, %%edx              /* dl = A ѡ */
        addl $0xa0000, %%eax

        movl %%eax, %%ebx           /* ebx = aU (0xa????) */

        movl %4, %%edi              /* edi = buff */

        call _setpage               /* 币 A */

        movl %6, %%ecx              /* ecx = y_width (A e U) */

hgGetImage256__lp_y:

        pushl %%ecx
        movl %%ebx, %%esi           /* esi =  aU w */
        addw %5, %%si               /* esi = esi + x_width */
        jc hgGetImage256__paging    /* 0xaffffa ae A */

        /* A ϩae w ----------------------------------------- */

hgGetImage256__no_paging:           /* A ϩae w */

        movl %5, %%ecx              /* a e  aa  */
        subw %5, %%si               /* si = si - x_width (aU ) */
        addl %0, %%esi              /* __djgpp_conventional_base  */
        cld
        REP
        movsb
        subl %0, %%esi              /* __djgpp_conventional_base ЁA */

        jmp hgGetImage256__next1

        /* A ϩae w ------------------------------------------- */

hgGetImage256__paging:

        subw %5, %%si               /* si = si - x_width (aU ) */
        movw %%si, %%cx
        negw %%cx                   /* cx = A w E  aa */
        addl %0, %%esi              /* __djgpp_conventional_base  */
        cld
        REP
        movsb
        subl %0, %%esi              /* __djgpp_conventional_base ЁA */

        movl %%ebx, %%esi           /*  aU  */
        addw %5, %%si               /* si = si + x_width */

        incl %%edx                  /* A ѡ wa */
        call _setpage               /* A */
        movw %%si, %%cx             /* cx = e  e U */
        xorw %%si, %%si             /* si = 0 (aU ba) */

        addl %0, %%esi              /* __djgpp_conventional_base  */
        REP
        movsb
        subl %0, %%esi              /* __djgpp_conventional_base ЁA */

hgGetImage256__next1:

        addw %1, %%bx               /* e aU  */
        cmpw %%si, %%bx             /*  弁 A a */
        jae hgGetImage256__next2    /* bx >= sie next2 (A ϩa) */

        incl %%edx                  /* bx < si e A ѡ wa */
        call _setpage               /* a A */

hgGetImage256__next2:

        popl %%ecx
        loop hgGetImage256__lp_y
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (px1), "g" (py1), "g" (buff), "g" (x_width), "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void hgPutImage256(int px1, int py1, int px2, int py2, byte *buff)
{
    int x_width = px2 - px1 + 1;
    int y_width = py2 - py1 + 1;

    __asm__ __volatile__("
        pushw %%es
        movw %0, %%es

        movl %4, %%esi

        movl %3, %%eax
        movl %1, %%ebx
        mulw %%bx
        addw %2, %%ax
        adcl $0, %%edx              /* dl = A ѡ */
        addl $0xa0000, %%eax        /* eax =  A   */

        movl %%eax, %%ebx           /* ebx = A aU (0xa????) */

        call _setpage               /* 币 A */

        movl %6, %%ecx              /* ecx = y_width (A e U) */

hgPutImage256__lp_y:

        pushl %%ecx
        movl %%ebx, %%edi           /* edi =  aU w */
        addw %5, %%di               /* di = di + x_width */
        jc hgPutImage256__paging    /* āa iae A */

        /* A ϩae w ----------------------------------------- */

hgPutImage256__no_paging:           /* A ϩae w */

        movl %5, %%ecx              /* a e  aa  */
        subw %5, %%di               /* di = di - x_width (aU ) */
        cld
        REP
        movsb

        jmp hgPutImage256__next1

        /* A ϩae w ------------------------------------------- */

hgPutImage256__paging:

        subw %5, %%di               /* di = di - x_width (aU ) */
        movw %%di, %%cx
        negw %%cx                   /* cx = A w E  aa */
        cld
        REP
        movsb

        movl %%ebx, %%edi           /*  aU  */
        addw %5, %%di               /* edi = edi + x_width */

        incl %%edx                  /* A ѡ wa */
        call _setpage               /* A */
        movw %%di, %%cx             /* cx = e  e U */
        xorw %%di, %%di             /* di = 0 (aU ba) */

        REP
        movsb

hgPutImage256__next1:

        addw %1, %%bx               /* e aU  */
        cmpw %%di, %%bx             /*  弁 A a */
        jae hgPutImage256__next2    /* bx >= die next2 (A ϩa) */

        incl %%edx                  /* bx < di e A ѡ wa */
        call _setpage               /* a A */

hgPutImage256__next2:

        popl %%ecx
        loop hgPutImage256__lp_y

        popw %%es
        "
        :
        : "g" (_dos_ds), "g" (hgXbyte),
          "g" (px1), "g" (py1), "g" (buff), "g" (x_width), "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );
}

