/*
**      a  w : scr16.c
**       I w : aa (16 a)
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


void hgScrUp16(int px1, int py1, int px2, int py2, int lines, byte bkcolor)
{
    int xs, xe;
    byte lmask, rmask;

    if ((px1 % 8 == 0) && ((px2 + 1) % 8 == 0)) {
        hgScrUp8x(px1, py1, px2, py2, lines, bkcolor);
        return;
    }

    xs = px1 / 8 + 1;
    xe = px2 / 8 - 1;

    rmask = get_rmask(px2);
    lmask = get_lmask(px1);

    scrup(xs, py1, xe, py2, lines);
    scrsideup(xs - 1, py1, py2, lines, lmask);
    scrsideup(xe + 1, py1, py2, lines, rmask);

    hgBoxFill16(px1, py2 - lines + 1, px2, py2, bkcolor);
}

void hgScrDown16(int px1, int py1, int px2, int py2, int lines, byte bkcolor)
{
    int xs, xe;
    byte lmask, rmask;

    if ((px1 % 8 == 0) && ((px2 + 1) % 8 == 0)) {
        hgScrDown8x(px1, py1, px2, py2, lines, bkcolor);
        return;
    }

    xs = px1 / 8 + 1;
    xe = px2 / 8 - 1;

    rmask = get_rmask(px2);
    lmask = get_lmask(px1);

    scrdn(xs, py1, xe, py2, lines);
    scrsidedn(xs - 1, py1, py2, lines, lmask);
    scrsidedn(xe + 1, py1, py2, lines, rmask);

    hgBoxFill16(px1, py1, px2, py1 + lines - 1, bkcolor);
}


/* ------------------------------------------------------------------------ */

void hgScrUp8x(int px1, int py1, int px2, int py2, int lines, byte bkcolor)
{
    int xs = px1 / 8;
    int xe = px2 / 8;

    scrup(xs, py1, xe, py2, lines);

    hgBoxFill8x(xs * 8, py2 - lines + 1, xe * 8 + 7, py2, bkcolor);
}

void hgScrDown8x(int px1, int py1, int px2, int py2, int lines, byte bkcolor)
{
    int xs = px1 / 8;
    int xe = px2 / 8;

    scrdn(xs, py1, xe, py2, lines);

    hgBoxFill8x(xs * 8, py1, xe * 8 + 7, py1 + lines - 1, bkcolor);
}

void scrup(int tx1, int py1, int tx2, int py2, int lines)
{
    int x_width = tx2 - tx1 + 1;
    int y_width = hgXbyte * lines;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %4, %%ecx
        subl %3, %%ecx
        subl %5, %%ecx
        incl %%ecx

        movl %3, %%eax
        movl %1, %%edx
        mulw %%dx
        addl %2, %%eax
        addl $0xa0000, %%eax
        addl %0, %%eax

        movl %%eax, %%ebx

        movl $0x03ce, %%edx
        movl $0x0105, %%eax
        outw %%ax, %%dx

scrup__uplp2:
        pushl %%ecx
        movl %6, %%ecx
        movl %%ebx, %%edi
        movl %%edi, %%esi
        addl %7, %%esi
        cld
        REP
        movsb
        addl %1, %%ebx
        popl %%ecx
        loop scrup__uplp2

        movl $0x0005, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx1), "g" (py1), "g" (py2), "g" (lines),
          "g" (x_width), "g" (y_width)

        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void scrdn(int tx1, int py1, int tx2, int py2, int lines)
{
    int x_width = tx2 - tx1 + 1;
    int y_width = hgXbyte * lines;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %4, %%ecx
        subl %3, %%ecx
        subl %5, %%ecx
        incl %%ecx

        movl %4, %%eax
        movl %1, %%edx
        mulw %%dx
        addl %2, %%eax
        addl $0xa0000, %%eax
        addl %0, %%eax
        movl %%eax, %%ebx

        movl $0x03ce, %%edx
        movl $0x0105, %%eax
        outw %%ax, %%dx

scrdn__dnlp2:
        pushl %%ecx
        movl %6, %%ecx
        movl %%ebx, %%edi
        movl %%edi, %%esi
        subl %7, %%esi
        cld
        REP
        movsb
        subl %1, %%ebx
        popl %%ecx
        loop scrdn__dnlp2

        movl $0x0005, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx1), "g" (py1), "g" (py2), "g" (lines),
          "g" (x_width), "g" (y_width)

        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void scrsideup(int tx, int py1, int py2, int lines, byte mask)
{
    int y_width = hgXbyte * lines;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %4, %%ecx
        subl %3, %%ecx
        subl %5, %%ecx
        incl %%ecx

        movl %3, %%eax
        movl %1, %%edx
        mulw %%dx
        addl %2, %%eax
        addl $0xa0000, %%eax
        addl %0, %%eax

        movl %%eax, %%ebx

        movl $0x03ce, %%edx
        movl $0x0005, %%eax
        outw %%ax, %%dx
        movl $0x0000, %%eax
        outw %%ax, %%dx

        movb $8, %%al
        movb %6, %%ah
        outw %%ax, %%dx

        movl %%ebx, %%edi
        movl %%edi, %%esi
        addl %7, %%esi

        subl $10, %%edx

scrsideup__uplp2:
        pushl %%ecx

        movl $3, %%ecx
        movb $8, %%bl

scrsideup__uplp3:
        addl $10, %%edx
        movb %%cl, %%ah
        movb $4, %%al
        outw %%ax, %%dx
        movb (%%esi), %%bh
        subl $10, %%edx
        movb $2, %%al
        movb %%bl, %%ah
        outw %%ax, %%dx
        movb (%%edi), %%ch
        movb %%bh, (%%edi)
        shrb $1, %%bl
        movb $0, %%ch
        decl %%ecx
        cmpl $-1, %%ecx
        jne scrsideup__uplp3

        addl %1, %%esi
        addl %1, %%edi

        popl %%ecx
        loop scrsideup__uplp2

        movl $0xff02, %%eax
        outw %%ax, %%dx

        movl $0x03ce, %%edx
        movl $0xff08, %%eax
        outw %%ax, %%dx
        movl $0xff04, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx), "g" (py1), "g" (py2), "g" (lines), "g" (mask),
          "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

void scrsidedn(int tx, int py1, int py2, int lines, byte mask)
{
    int y_width = hgXbyte * lines;

    if (!__djgpp_nearptr_enable()) return;

    __asm__ __volatile__("
        movl %4, %%ecx
        subl %3, %%ecx
        subl %5, %%ecx
        incl %%ecx

        movl %4, %%eax
        movl %1, %%edx
        mulw %%dx
        addl %2, %%eax
        addl $0xa0000, %%eax
        addl %0, %%eax

        movl %%eax, %%ebx

        movl $0x03ce, %%edx
        movl $0x0005, %%eax
        outw %%ax, %%dx
        movl $0x0000, %%eax
        outw %%ax, %%dx

        movb $8, %%al
        movb %6, %%ah
        outw %%ax, %%dx

        movl %%ebx, %%edi
        movl %%edi, %%esi
        subl %7, %%esi
        subl $10, %%edx

scrsidedn__uplp2:
        pushl %%ecx

        movl $3, %%ecx
        movb $8, %%bl

scrsidedn__uplp3:
        addl $10, %%edx
        movb %%cl, %%ah
        movb $4, %%al
        outw %%ax, %%dx
        movb (%%esi), %%bh
        subl $10, %%edx
        movb $2, %%al
        movb %%bl, %%ah
        outw %%ax, %%dx
        movb (%%edi), %%ch
        movb %%bh, (%%edi)
        shrb $1, %%bl
        movb $0, %%ch
        decl %%ecx
        cmpl $-1, %%ecx
        jne scrsidedn__uplp3

        subl %1, %%esi
        subl %1, %%edi

        popl %%ecx
        loop scrsidedn__uplp2

        movl $0xff02, %%eax
        outw %%ax, %%dx

        movl $0x03ce, %%edx
        movl $0xff08, %%eax
        outw %%ax, %%dx
        movl $0xff04, %%eax
        outw %%ax, %%dx
        "
        :
        : "g" (__djgpp_conventional_base), "g" (hgXbyte),
          "g" (tx), "g" (py1), "g" (py2), "g" (lines), "g" (mask),
          "g" (y_width)
        : "ax", "bx", "cx", "dx", "si", "di", "memory"
    );

    __djgpp_nearptr_disable();
}

