/*
**      a  w : hhelp.c
**       I w : HHELP s aaw
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"
#include "_keycode.h"


hgHHELP *hgHHELP_Load(byte *i[], int xc, int yl)
{
    hgHHELP *p;
    int pointer = 0;

    p = (hgHHELP *)malloc(sizeof(hgHHELP));

    while (strcmp(i[pointer], "")) {
        p->items[pointer] = (byte *)malloc(strlen(i[pointer]) + 2);
        strcpy(p->items[pointer], i[pointer]);
        pointer++;
    }

    p->items[pointer] = (byte *)malloc(3);
    strcpy(p->items[pointer], "");

    p->xchars = xc;
    p->ylines = yl;

    return p;
}

void hgHHELP_Free(hgHHELP **p)
{
    int pos = 0;

    while (strcmp((*p)->items[pos], ""))
        free((*p)->items[pos++]);
    if ((*p)->items[pos]) free((*p)->items[pos]);
    free(*p);
}

void hgHHELP_Draw(hgHHELP *p, int px, int py, byte *title)
{
    int bpos = 0;
    int xsize, ysize;
    int prvs, sline, ch;

    hgHSCRLBAR *sbar;
    hgWIDTH sbarw;

    bpos = ret_number(p->items) / 16 / hgYFactor;
    xsize = p->xchars * 8 + 28;
    ysize = p->ylines * 16 + 32 + 12 + 4 - 1;

    hgWIDTH_Load(&sbarw, 16, p->ylines * 16 + 3);
    sbar = hgHSCRLBAR_Load(bpos, p->ylines, VERT, sbarw);
    hgPrtWindowPXy(px, py, px + xsize + 16, py + ysize, title);
    hgHSCRLBAR_Draw(sbar, px + xsize - 12, py + 33);
    prvs = sline = 0;
    print_help_sub(px + 14, py + 34, p->items, bpos, sline, p->ylines, xsize - 28);
    while (1) {
        do ch = inkey(hgNOWAIT);
        while (ch == hgNOKEY);

        prvs = sline;
        if (ch == PgDn) {
            sline += p->ylines;
            if (sline >= bpos) sline -= p->ylines;
        }
        if (ch == PgUp) {
            sline -= p->ylines;
            if (sline < 0) sline = 0;
        }
        if (ch == END || ch == CTRL_PgDn) {
            sline = bpos - p->ylines;
            if (sline < 0) sline = 0;
        }
        if (ch == HOME || ch == CTRL_PgUp) sline = 0;
        if (ch == ESC || ch == ALT_X || ch == RETURN) break;
        if (prvs != sline) {
            print_help_sub(px + 14, py + 34, p->items, bpos, sline, p->ylines, xsize - 48 + 16 + 3);
            sbar->pos = sline;
            hgHSCRLBAR_Update(sbar, px + xsize - 12, py + 33);
        }
        if (ch == UP) {
            sline--;
            if (sline < 0) sline = 0;
            else {
                hgScrDownWindowPXy(px, py, px + xsize, py + ysize, 16);
                hgPutsPXy(px + 14, py + 34, p->items[sline]);
                sbar->pos = sline;
                hgHSCRLBAR_Update(sbar, px + xsize - 12, py + 33);
            }
        }
        if (ch == DOWN) {
            sline++;
            if (sline + p->ylines - 1 >= bpos) sline--;
            else {
                hgScrUpWindowPXy(px, py, px + xsize, py + ysize, 16);
                hgPutsPXy(px + 14, py + (p->ylines - 1) * 16 + 34, p->items[sline + p->ylines - 1]);
                sbar->pos = sline;
                hgHSCRLBAR_Update(sbar, px + xsize - 12, py + 33);
            }
        }
    }
    hgHSCRLBAR_Free(&sbar);
}

void print_help_sub(int px, int py, byte *buff[], int max, int sline, int ylines, int xsize)
{
    int i, j;

    for (i = 0; i < ylines; i++) {
        hgBoxFillPXy(px, py, px + xsize, py + 16, hgWHITE);
        hgPutsPXy(px, py, buff[sline]);
        sline++;
        py += 16;
        if (sline >= max) break;
    }
    for (j = i + 1; j < ylines; j++) {
        hgBoxFillPXy(px, py, px + xsize, py + 16, hgWHITE);
        py += 16;
    }
}

