/*
**      a  w : hicon.c
**       I w : HICON  aaw
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"


hgHICON *hgHICON_Load(byte *fname)
{
    byte hdr[40];
    int size, xs, ys;
    FILE *fpt;
    hgHICON *p;

    fpt = fopen(fname, "rb");
    if (fpt == NULL) return NULL;

    p = (hgHICON *)malloc(sizeof(hgHICON));

    fseek(fpt, 31, 0);
    xs = getc(fpt);
    ys = getc(fpt);
    fseek(fpt, 0, 0);
    fread(hdr, 33, 1, fpt);
    size = xs * 4 * ys;
    p->buff = (byte *)malloc(size);
    fread(p->buff, size, 1, fpt);
    fclose(fpt);
    p->size.xwidth = xs;
    p->size.ywidth = ys;

    return p;
}

void hgHICON_Free(hgHICON **p)
{
    free((*p)->buff);
    free(*p);
}

void hgHICON_Draw(hgHICON *p, int px, int py)
{
    int i, j, pos;

    for (i = 0; i < p->size.ywidth; i++) {
        for (j = 0; j < p->size.xwidth * 4; j++) {
            pos = get_pos(p, j, i);
            hgPlot(px + j * 2, py + i, (p->buff[pos] & 0xf0) >> 4);
            hgPlot(px + j * 2 + 1, py + i, (p->buff[pos] & 0x0f));
        }
    }
}

hgHICON *hgHICON_Set(void (*iconset)(hgHICON *p))
{
    hgHICON *p;

    p = (hgHICON *)malloc(sizeof(hgHICON));
    (*iconset)(p);

    return p;
}

int hgHICON_IsIcon(byte *fname)
{
    int offset, size, xs, ys;
    FILE *f;

    f = fopen(fname, "rb");
    if (f == NULL) return -1;           /* for error */

    fseek(f, 31, 0);
    xs = getc(f);
    ys = getc(f);
    fseek(f, 0, 2);
    size = xs * ys * 4 + 33;
    offset = ftell(f);
    fclose(f);

    if (size != offset) return 0;
    else return 1;
}

int get_pos(hgHICON *p, int px, int py)
{
    return (p->size.xwidth * py * 4 + px);
}

