/*
**      a  w : hpulldn.c
**       I w : HPULLDOWN s aaw
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"
#include "_keycode.h"


hgHPULLDOWN *hgHPULLDOWN_Load(byte *i[], int x[MAXITEM], hgWIDTH w, hgHPOPUP *pop[MAXPOPUP])
{
    hgHPULLDOWN *p;
    int pointer = 0;
    int ii;

    p = (hgHPULLDOWN *) malloc(sizeof(hgHPULLDOWN));

    while (strcmp(i[pointer], "")) {
        p->items[pointer] = (byte *)malloc(strlen(i[pointer])+2);
        strcpy(p->items[pointer], i[pointer]);
        pointer++;
    }

    for (ii = 0; ii < pointer; ii++) {
        p->xpos[ii] = x[ii];
        p->p[ii] = pop[ii];
        p->code[ii] = hgEnable;
    }

    p->items[pointer] = (byte *)malloc(3);
    strcpy(p->items[pointer], "");

    p->start = 0;
    p->size = w;

    return p;
}

void hgHPULLDOWN_Loadcode(hgHPULLDOWN *p, int c[MAXITEM])
{
    int i;

    for (i = 0; i < MAXITEM; i++) {
        if (!strcmp(p->items[i], "")) break;
        p->code[i] = c[i];
    }
}

void hgHPULLDOWN_Free(hgHPULLDOWN **p)
{
    int pos = 0;
    while (strcmp((*p)->items[pos], ""))
        free((*p)->items[pos++]);
    if ((*p)->items[pos]) free((*p)->items[pos]);
    free (*p);
}

void hgHPULLDOWN_Choose(hgHPULLDOWN *p, int px, int py, int start, int *xx, int *yy)
{
    hgHBAR *bar;
    hgBCOLOR bc;
    hgWIDTH bw;

    int ch, num, i, prvs, ret = 0;

    if (start < 0) start = p->start;
    num = ret_number(p->items) / 16 / hgYFactor;

    while (p->code[start] == hgDisable) {
        start++;
        if (start<0) start = num - 1;
        if (start>num-1) start = 0;
    }

    prvs = start;

    hgBCOLOR_Load(&bc, wcBARNORMAL, wcBARNORMAL);
    hgDrawBorder(px, py, px + p->size.xwidth, py + 14 + 16 * hgYFactor, BOXNORMAL, FILL);
    maxlen = ret_maxlength(p->items) + 10;
    hgWIDTH_Load(&bw, maxlen, 4 + 16 * hgYFactor);
    bar = hgHBAR_Load(bc, bw);

    for (i = 0; i < num; i++) {
        if (p->code[i] == hgDisable) {
            hgSetEngAttr(hgDIM);
            hgSetHanAttr(hgDIM);
        }
        hgPutsPXy(px + p->xpos[i], py + 8, p->items[i]);
        if (p->code[i] == hgDisable) {
            hgSetEngAttr(hgNORMAL);
            hgSetHanAttr(hgNORMAL);
        }
        xb[i] = px + p->xpos[i] - 5;
        xw[i] = maxlen;
        xe[i] = p->code[i];
    }

    xn = num;

    do {
        hgHBAR_Draw(bar, px + p->xpos[start] - 5, py + 5, DRAW);
        prvs = start;
        while (1) {
            do {
                ch = inkey(hgNOWAIT);
            } while (ch == hgNOKEY);
            if (ch == ESC || ch == RETURN || ch == DOWN) {
                hgHBAR_Draw(bar, px + p->xpos[prvs] - 5, py + 5, ERASE);
                break;
            }
            if (ch == LEFT) start--;
            if (ch == RIGHT) start++;
            if (start < 0) start = num - 1;
            if (start > num - 1) start = 0;
            while (p->code[start] == hgDisable) {
                if (ch == LEFT) start--;
                else start++;
                if (start < 0) start = num - 1;
                if (start > num - 1) start = 0;
            }
            if (start != prvs) {
                hgHBAR_Draw(bar, px + p->xpos[prvs] - 5, py + 5, ERASE);
                hgHBAR_Draw(bar, px + p->xpos[start] - 5, py + 5, DRAW);
                prvs = start;
            }
        }
        if (ch == ESC) {
            p->start = start;
            hgHBAR_Free(&bar);
            *xx = -1;
            *yy = -1;
            return;
        }

        do {
            xp = start;
            hgHBAR_Draw(bar, px + p->xpos[start] - 5, py + 5, DRAW);
            ret = hgHPOPUP_Choose(p->p[start], px + p->xpos[start] - 5, py + 14 + 16 * hgYFactor, -1);
            hgHBAR_Draw(bar, px + p->xpos[start] - 5, py + 5, ERASE);
            if (ret == -LEFT) start--;
            else if (ret == -RIGHT) start++;
            else if (ret == -1) break;        /* for ESC */
            else if (ret == -2) start = xp;
            else break;                     /* for adequate value */
            if (start < 0) start = num - 1;
            if (start > num - 1) start = 0;
            while (p->code[start] == hgDisable) {
                if (ret == -LEFT) start--;
                else start++;
                if (start < 0) start = num - 1;
                if (start > num - 1) start = 0;
            }
        } while (1);
        p->start = start;
    } while (ret == -1);

    *xx = start;
    *yy = ret;

    hgHBAR_Free(&bar);

    maxlen = -1;

    if (ch == ESC) {
        *xx = -1;
        *yy = -1;
        return;
    }
    return;
}

