/*
**      a  w : hscrlbar.c
**       I w : HSCRLBAR  aaw
**
**      Aba : e (HiTEL : hwjketel)
**      GCC ͡˷ : ⣥ (PCHacker@hitel.net)
**
**      aw : 99e 12 31 - qe ͡
**
*/


#include "libhandj.h"
#include "_keycode.h"


hgHSCRLBAR *hgHSCRLBAR_Load(int total, int screen, int direc, hgWIDTH w)
{
    hgHSCRLBAR *p;

    p = (hgHSCRLBAR *)malloc(sizeof(hgHSCRLBAR));

    if (total < screen) total = screen;

    p->total = total;
    p->screen = screen;
    p->direc = direc;
    p->size = w;
    p->pos = 0;

    return p;
}

void hgHSCRLBAR_Free(hgHSCRLBAR **p)
{
    free(*p);
}

void hgHSCRLBAR_Draw(hgHSCRLBAR *p, int px, int py)
{
    int px1, px2, py1, py2;
    int width, bwidth, start;

    px1 = px;
    px2 = px + p->size.xwidth;
    py1 = py;
    py2 = py + p->size.ywidth;

    if (p->direc == HORIZ) width = px2 - px1 - 44;
    else width = py2 - py1 - 44;

    if (p->total != 0) {
        start = p->pos * width / p->total;
        bwidth = p->screen * width / p->total;
    } else {
        bwidth = width;
        start = 0;
    }

    if (p->direc == VERT) {
        hgBoxFillPXy(px1 + 1, py1, px1 + 16, py2, hgLIGHTGRAY);
        hgBox(px1, py1, px1 + 16, py2, hgDARKGRAY);
        hgLine(px1 + 1, py1 + 20, px1 + 15, py1 + 20, hgBLACK);
        hgLine(px1 + 1, py2 - 20, px1 + 16, py2 - 20, hgBLACK);

        hgLine(px1 + 8, py1 + 3, px1 + 3, py1 + 16, hgWHITE);
        hgLine(px1 + 8, py1 + 3, px1 + 13, py1 + 16, hgBLACK);
        hgLine(px1 + 3, py1 + 16, px1 + 13, py1 + 16, hgBLACK);

        hgLine(px1 + 8, py2 - 3, px1 + 3, py2 - 16, hgWHITE);
        hgLine(px1 + 8, py2 - 3, px1 + 13, py2 - 16, hgBLACK);
        hgLine(px1 + 3, py2 - 16, px1 + 13, py2 - 16, hgBLACK);

        hgLine(px1 + 2, py1 + 22 + start, px1 + 14, py1 + 22 + start, hgWHITE);
        hgVLine(px1 + 2, py1 + 22 + start, py1 + 22 + start + bwidth, hgWHITE);
        hgLine(px1 + 2, py1 + 22 + start + bwidth, px1 + 14, py1 + 22 + start + bwidth, hgBLACK);
        hgVLine(px1 + 14, py1 + 22 + start, py1 + 22 + start + bwidth, hgBLACK);
    } else {
        hgBoxFillPXy(px1, py1 + 1, px2, py1 + 16, hgLIGHTGRAY);
        hgBox(px1, py1, px2, py1 + 16, hgDARKGRAY);
        hgVLine(px1 + 20, py1 + 1, py1 + 15, hgBLACK);
        hgVLine(px2 - 20, py1 + 1, py1 + 15, hgBLACK);

        hgLine(px1 + 3, py1 + 8, px1 + 16, py1 + 3, hgWHITE);
        hgLine(px1 + 3, py1 + 8, px1 + 16, py1 + 13, hgBLACK);
        hgLine(px1 + 16, py1 + 3, px1 + 16, py1 + 13, hgBLACK);

        hgLine(px2 - 3, py1 + 8, px2 - 16, py1 + 3, hgWHITE);
        hgLine(px2 - 3, py1 + 8, px2 - 16, py1 + 13, hgBLACK);
        hgLine(px2 - 16, py1 + 3, px2 - 16, py1 + 13, hgBLACK);

        hgHLine(px1 + 22 + start, px1 + 22 + start + bwidth, py + 2, hgWHITE);
        hgHLine(px1 + 22 + start, px1 + 22 + start + bwidth, py + 14, hgBLACK);
        hgVLine(px1 + 22 + start, py1 + 2, py1 + 14, hgWHITE);
        hgVLine(px1 + 22 + start + bwidth, py1 + 2, py1 + 14, hgBLACK);
    }
}

void hgHSCRLBAR_Update(hgHSCRLBAR *p, int px, int py)
{
    int px1, px2, py1, py2;
    int width, bwidth, start, save;

    px1 = px;
    px2 = px + p ->size.xwidth;
    py1 = py;
    py2 = py + p->size.ywidth;

    if (p->direc == HORIZ) width = px2 - px1 - 44;
    else width = py2 - py1 - 44;

    save = p->pos;
    if ((p->pos + p->screen) > p->total) p->pos = p->total - p->screen;

    if (p->total != 0) {
        start = p->pos * width / p->total;
        bwidth = p->screen * width / p->total;
    } else {
        bwidth = width;
        start = 0;
    }

    if (p->direc == VERT) {
        hgBoxFillPXy(px1 + 2, py1 + 21, px1 + 14, py2 - 21, hgLIGHTGRAY);
        hgLine(px1 + 2, py1 + 22 + start, px1 + 14, py1 + 22 + start, hgWHITE);
        hgVLine(px1 + 2, py1 + 22 + start, py1 + 22 + start + bwidth, hgWHITE);
        hgLine(px1 + 2, py1 + 22 + start + bwidth, px1 + 14, py1 + 22 + start + bwidth, hgBLACK);
        hgVLine(px1 + 14, py1 + 22 + start, py1 + 22 + start + bwidth, hgBLACK);
    } else {
        hgBoxFillPXy(px1 + 22, py1 + 2, px2 - 22, py1 + 14, hgLIGHTGRAY);
        hgHLine(px1 + 22 + start, px1 + 22 + start + bwidth, py + 2, hgWHITE);
        hgHLine(px1 + 22 + start, px1 + 22 + start + bwidth, py + 14, hgBLACK);
        hgVLine(px1 + 22 + start, py1 + 2, py1 + 14, hgWHITE);
        hgVLine(px1 + 22 + start + bwidth, py1 + 2, py1 + 14, hgBLACK);
    }
    p->pos = save;
}

